# SeismicUnixGui
SeismicUnixGui (alpha) is a graphical user interface (GUI) to select parameters for Seismic Unix (SU) modules. 
Seismic Unix (Stockwell, 1999) is a widely distributed free software package for processing seismic reflection
and signal processing.  Perl/Tk is a mature, well-documented and free object-oriented graphical user interface for Perl.  
In a classroom environment, shell scripting of SU modules engages students and helps focus on the theoretical limitations
and strengths of signal processing.  However, complex interactive processing stages, e.g., selection of optimal 
stacking velocities, killing bad data traces, or spectral analysis requires advanced flows beyond the scope of 
introductory classes.  In a research setting, special functionality from other free seismic processing software 
such as SioSeis (UCSD-NSF) can be incorporated readily via an object-oriented style to programming.
An object oriented approach is a first step toward efficient extensible programming of multi-step processes, 
and a simple GUI simplifies parameter selection and decision making.  Currently, in L_SU, Perl 5 packages 
wrap nearyly 300 SU modules that are used in teaching undergraduate and first-year graduate student 
classes (e.g., filtering, display, velocity analysis and stacking).  Perl packages (classes) can advantageously
add new functionality around each module and clarify parameter names for easier usage.  For example, through 
the use of methods, packages can isolate the user from repetitive control structures, as well as replace the 
names of abbreviated parameters with self-describing names.  Moose, an extension of the Perl 5 object system, 
greatly facilitates an object-oriented style.  Perl wrappers are self-documenting via Perl programming document 
markup language.  

NOTES: July 14, 2022
Author: Juan M. Lorenzo
Version: 1.00.00 

PURPOSE: Help install application manually


STEP 1: 

Run the following commands, preferably as sudo.

sudo perl Makefile.PL
sudo make all
sudo make install
sudo make clean


STEP 2:

Run the application at the command line:

SeismicUnixGui

=head2 Instructions

=cut 


=head3  In order to create an su module for
incorporation into L_SU 

 you will need access to the self-instructions of the
 seismic unix module, which I find in:
  /usr/local/pl/L_SU/developer/Stripped/'group of programs'
where 'group of programs' is a generic type of programs, e.g.
modeling programs are found within the folder called:
'model'

 1. modify the following:

  sudoc2pm.pl

  by adding lines, such as the following:
  
 e.g., group=8 is the group of modeling
 programs whose readme files are 
 found in ~developer/Stripped/model
 
   my $group_no = 8;  
   my $selected_program_name = 'sufctanismod';

 2. run the following:

  perl sudoc2pm.pl ( under ~L_SU)

=cut

C***********************************************************************
C***********************************************************************
C TYPES TEXT AND CURRENT VALUE OF PARAMETER.
C   IF NEW LINE IS TYPED IN RESPONSE, OLD VALUE IS RETURNED.
C   OTHERWISE PARAMETER IS UPDATED WITH VAULE ENTERED IN RESPONSE.
	SUBROUTINE READ_PAR_I4(TEXT,PAR1)
	INTEGER*4 PAR1,PARI4
	CHARACTER*(*) TEXT
	INTEGER SPACE_POS
	CHARACTER*80 BUFFER
	CHARACTER*80 FILL/' '/
	CHARACTER*4 I_FORMAT/'(I1)'/
C	CHARACTER*8 R_FORMAT/'(F10.0)'/
	PARI4=PAR1
C
C GET LENGTH OF TEXT STRING
C
	ILEN=LEN(TEXT)
	JLEN=1
	IF(ILEN.LT.50) JLEN=50-ILEN
C
 100	WRITE(*,*)TEXT,FILL(:JLEN),' I*4 [',PARI4,'] '
!              WRITE(*,*) 'readpar.for L23'
C
	READ(*,'(A)')BUFFER
!	WRITE(*,*) 'readpar.for L26'
	SPACE_POS=INDEX(BUFFER,' ')
!	WRITE(*,*) 'readpar.for L27'
	IF (SPACE_POS.EQ.1) RETURN
!	WRITE(*,*) 'readpar.for L29'
C
		WRITE(I_FORMAT(3:3),'(I1)',ERR=200)SPACE_POS-1
		READ(BUFFER,I_FORMAT,ERR=200)PARI4
	PAR1=PARI4
!	WRITE(*,*) 'readpar.for L32'
	RETURN
 200	WRITE(*,'(1X,A)')'TYPING ERROR, TRY AGAIN<CR>'
	GO TO 100

	WRITE(*,*) 'readpar.for L36'

	END
C***********************************************************************
C TYPES TEXT AND CURRENT VALUE OF PARAMETER.
C IF NEW LINE IS TYPED IN RESPONSE, OLD VALUE IS RETURNED.
C OTHERWISE PARAMETER IS UPDATED WITH VAULE ENTERED IN RESPONSE.
	SUBROUTINE READ_PAR_I2(TEXT,PAR1)
	INTEGER*2 PAR1,PARI2
	CHARACTER*(*) TEXT
	INTEGER SPACE_POS
	CHARACTER*80 BUFFER
	CHARACTER*80 FILL/' '/
	CHARACTER*4 I_FORMAT/'(I1)'/
C	CHARACTER*8 R_FORMAT/'(F10.0)'/
	PARI2=PAR1
C
C GET LENGTH OF TEXT STRING
C
	ILEN=LEN(TEXT)
	JLEN=1
	IF(ILEN.LT.50) JLEN=50-ILEN
C
 100	WRITE(*,*)TEXT,FILL(:JLEN),' I*2 [',PARI2,'] '
C
	READ(*,'(A)')BUFFER
	SPACE_POS=INDEX(BUFFER,' ')
	IF (SPACE_POS.EQ.1) RETURN
C
		WRITE(I_FORMAT(3:3),'(I1)',ERR=200)SPACE_POS-1
		READ(BUFFER,I_FORMAT,ERR=200)PARI2
	PAR1=PARI2
	RETURN
 200	WRITE(*,'(1X,A)')'TYPING ERROR, TRY AGAIN<CR>'
	GO TO 100
	END
C***********************************************************************
C TYPES TEXT AND CURRENT VALUE OF PARAMETER.
C IF NEW LINE IS TYPED IN RESPONSE, OLD VALUE IS RETURNED.
C OTHERWISE PARAMETER IS UPDATED WITH VAULE ENTERED IN RESPONSE.
	SUBROUTINE READ_PAR_R4(TEXT,PAR1)
	REAL*4 PAR1,PARR4
	CHARACTER*(*) TEXT
	INTEGER SPACE_POS
	CHARACTER*80 BUFFER
	CHARACTER*80 FILL/' '/
C	CHARACTER*4 I_FORMAT/'(I1)'/
	CHARACTER*8 R_FORMAT/'(F10.0)'/
	PARR4=PAR1
C
C GET LENGTH OF TEXT STRING
C
	ILEN=LEN(TEXT)
	JLEN=1
	IF(ILEN.LT.50) JLEN=50-ILEN
C
 100	WRITE(*,*)TEXT,FILL(:JLEN),' R*4 [',PARR4,'] '
C
	READ(*,'(A)')BUFFER
	SPACE_POS=INDEX(BUFFER,' ')
	IF (SPACE_POS.EQ.1) RETURN
C
		WRITE(R_FORMAT(3:4),'(I2.2)',ERR=200)SPACE_POS-1
		READ(BUFFER,R_FORMAT,ERR=200)PARR4
	PAR1=PARR4
	RETURN
 200	WRITE(*,'(1X,A)')'TYPING ERROR, TRY AGAIN<CR>'
	GO TO 100
	END
C***********************************************************************
C TYPES TEXT AND CURRENT VALUE OF PARAMETER.
C IF NEW LINE IS TYPED IN RESPONSE, OLD VALUE IS RETURNED.
C OTHERWISE PARAMETER IS UPDATED WITH VAULE ENTERED IN RESPONSE.
	SUBROUTINE READ_PAR_R8(TEXT,PAR1)
	REAL*8 PAR1,PARR8
	CHARACTER*(*) TEXT
	INTEGER SPACE_POS
	CHARACTER*80 BUFFER
	CHARACTER*80 FILL/' '/
	CHARACTER*8 R_FORMAT/'(F10.0)'/
	PARR8=PAR1
C
C GET LENGTH OF TEXT STRING
C
	ILEN=LEN(TEXT)
	JLEN=1
	IF(ILEN.LT.50) JLEN=50-ILEN
C
 100	WRITE(*,*)TEXT,FILL(:JLEN),' R*8 [',PARR8,'] '
C
	READ(*,'(A)')BUFFER
	SPACE_POS=INDEX(BUFFER,' ')
	IF (SPACE_POS.EQ.1) RETURN
C
		WRITE(R_FORMAT(3:4),'(I2.2)',ERR=200)SPACE_POS-1
		READ(BUFFER,R_FORMAT,ERR=200)PARR8
	PAR1=PARR8
	RETURN
 200	WRITE(*,'(1X,A)')'TYPING ERROR, TRY AGAIN<CR>'
	GO TO 100
	END
C***********************************************************************

	SUBROUTINE DENFVP(VP,D,IOP)
C
C COMPUTES DENSITY D (GR/CC) FROM P-WAVE VELOCITY VP (KM/SEC)
C
C IOP=1 : D=1.74*VP**0.25 ,GARDNER ET AL.,GEOPHYSICS 39,P 770-780,1974
C
C IOP=2 : D=1.85+0.165*VP ,CHRISTENSEN AND SHAW, GEOPHYS.J.R.ASTR.SOC
C                          20,P 271-284,1970. FOR BASALTIC SAMPLES AT
C                          1 KBAR.
C
C IOP=3 : NAFE AND DRAKE, THE SEA, VOL.4,PART 1,WILEY-INTERSCIENCES,NEW
C         YORK,1970.
C
	IF(IOP.EQ.1) THEN
	D=1.74*VP**0.25
	RETURN
	ENDIF
C
	IF(IOP.EQ.2) THEN
	D=1.85+0.165*VP
	RETURN
	ENDIF
C
	IF(IOP.EQ.3) THEN
C
		IF(VP.LT.1.7) THEN
		D=0.05+VP
		RETURN
		ENDIF
C
		IF(VP.LT.2.2) THEN
		D=1.75+0.5*(VP-1.7)
		RETURN
		ENDIF
C
		IF(VP.LT.3.2) THEN
		D=2.0 +0.25*(VP-2.2)
		RETURN
		ENDIF
C
		IF(VP.LT.6.2) THEN
		D=2.25+(VP-3.2)/6.0
		RETURN
		ENDIF
C
		IF(VP.LT.7.2) THEN
		D=2.75+0.25*(VP-6.2)
		RETURN
		ENDIF
C
		IF(VP.LT.8.6) THEN
		D=3.0 +(VP-7.2)/2.8
		RETURN
		ENDIF
C
		IF(VP.GE.8.6) THEN
		D=3.5 +(VP-8.6)/2.6
		RETURN
		ENDIF
C
	ENDIF
	RETURN
        END

      subroutine read_immodpg_config (base_file,results,inbound)
         implicit none
!       read a configuration file

      integer*2 :: result
      character (len=80) :: name, answer
      character (len=30) :: format0,format1,format2,format3
      character (len=30) :: format4,format5,format6
      character (len=30) :: format7,format8,format9
      character (len=30) :: format10,format11,format12,format13
      character (len=30) :: format14,format15,format16,format17
      character (len=30) :: format18,format19
      character (len=5)  :: equal,previous_model,new_model
      character (len=5)  :: pre_digitized_XT_pairs,data_traces
      character (len=40) :: base_file
      character (len=255):: inbound, inbound_locked
      real               :: min_t_s,max_t_s,min_x_m,max_x_m
      real               :: thickness_increment_m
      real               :: data_x_inc_m,source_depth_m,receiver_depth_m
      real               :: reducing_vel_mps,plot_min_x_m,plot_max_x_m
      real               :: plot_min_t_s,plot_max_t_s,VtopNbot_factor
      real               :: Vincrement_mps, clip, m2km
      real*4             :: results(30)
      integer*2          :: layer
      integer            :: err_msg, counter, ready
      
!     in case definition in main is slightly different
!     pre_digitized_XT_pairs = 'no'
!     data_traces = 'no'
!     previous_model = 'no'
!     new_model = 'no'
!     sum of first two character strings= 35
      inbound_locked=trim(inbound)//"_locked"
      format0= "(A14,21X,A1,1X,A)"
      format1= "(A22,13X,A1,1X,A)"
      format2= "(A11,24X,A1,1X,A)"
      format3= "(A4,31X,A1,1X,F5.1)"
      format4= "(A7,28X,A1,1X,F10.3)"
      format5= "(A7,28X,A1,1X,F10.3)"
      format6= "(A13,22X,A1,1X,F10.3)"
      format7= "(A14,21X,A1,1X,F10.3)"
      format8= "(A16,19X,A1,1X,F10.3)"
      format9= format8
      format10="(A12,23X,A1,1X,F10.3)"
      format11= format10
      format12= format10
      format13= format10
      format14= "(A14,21X,A1,1X,A)"
      format15= "(A9,26X,A1,1X,A)"
      format16= "(A5,30X,A1,1X,I2)"
      format17= "(A15,20X,A1,1X,F10.3)"
      format18= "(A14,21X,A1,1X,F10.3)"
      format19= "(A21,14X,A1,1X,F10.3)"
      m2km = .001;

!      print*, 'read_immodpg_config.f, inbound is:', trim(inbound)

!      create a temporary, new, lock file
10     open(status='new',unit=2,file=inbound_locked,iostat=ready)

       if (ready.eq.0) then

        open(unit=1,file=trim(inbound),status='old',iostat=err_msg)

!       check whether file opens data file
        if (err_msg.eq.0) then

         read (1,format0) name,equal,base_file
         base_file = trim(base_file)
 !        print*, '0. read_immodpg_config.f, base file_name:',base_file
         read (1,format1) name,equal,pre_digitized_XT_pairs
!        print*, '1. read_immodpg_config.f, pre_digitized_XT_pairs:',
!     +  pre_digitized_XT_pairs
         read (1,format2) name,equal,data_traces
!       print*, '2. read_immodpg_config.f, data_traces:',data_traces
         read (1,format3) name,equal,clip
!       print*, '3. read_immodpg_config.f, clip:',clip
         read (1,format4) name,equal,min_t_s
         read (1,format5) name,equal,min_x_m
         read (1,format6) name,equal,data_x_inc_m
         read (1,format7) name,equal,source_depth_m
         read (1,format8) name,equal,receiver_depth_m
         read (1,format9) name,equal,reducing_vel_mps
         read (1,format10) name,equal,plot_min_x_m
         read (1,format11) name,equal,plot_max_x_m
         read (1,format12) name,equal,plot_min_t_s
         read (1,format13) name,equal,plot_max_t_s
!      print*, '4. read_immodpg_config.f, min_t_s:',min_t_s
!      print*, '5. read_immodpg_config.f, min_x_m:',min_x_m
!      print*, '6. read_immodpg_config.f, data_x_inc_m:',
!     + real(data_x_inc_m)
!      print*, '7. read_immodpg_config.f, source_depth_m:',
!     + source_depth_m
!      print*,'8. read_immodpg_config.f,receiver_depth_m:',
!     + receiver_depth_m
!       print*,'9?. read_immodpg_config.f, reducing_vel_mps:',
!     + reducing_vel_mps
!       print*, '10. read_immodpg_config.f, plot_min_x_m:',plot_min_x_m
!       print*, '11. read_immodpg_config.f, plot_max_x_m:',plot_max_x_m
!       print*, '12.read_immodpg_config.f, plot_min_t_s:',plot_min_t_s
!       print*, '13. read_immodpg_config.f, plot_max_t_s:',plot_max_t_s
         read (1,format14) name,equal,previous_model
!       print*, '14.read_immodpg_config.f, previous_model:',
!     +previous_model,'--'
         read (1,format15) name,equal,new_model
!       print*, '15.read_immodpg_config.f, new_model:',new_model
         read (1,format16) name,equal,layer
!       print*,'16.read_immodpg_config.f, layer:',
!     + layer
         read (1,format17) name,equal,VtopNbot_factor
!       print*,'17.read_immodpg_config.f, ,VtopNbot_factor:'
!     + ,VtopNbot_factor
         read (1,format18) name,equal,Vincrement_mps
!       print*,'18.read_immodpg_config.f,Vincrement_mps:'
!     + ,Vincrement_mps
         read (1,format19) name,equal,thickness_increment_m
!       print*,'19.read_immodpg_config.f,thickness_increment_m:'
!     + ,thickness_increment_m
         if (base_file .ne. '') then
!        print*, 'Found it,read_immodpg_config.f, base_file:',base_file
         else
          print*, 'read_immodpg_config.f, base_file missing:'
         end if

         if (pre_digitized_XT_pairs == 'yes') then
          results(1) = 1.
         else
          results(1) = 0.
         end if

         if (data_traces == 'yes') then
          results(2) = 1.
         else
          results(2) = 0.
         end if

         results(3) = real(clip)
         results(4) = min_t_s
         results(5) = min_x_m * m2km
         results(6) = real(data_x_inc_m) * m2km
         results(7) = source_depth_m * m2km
         results(8) = receiver_depth_m * m2km
         results(9) = reducing_vel_mps * m2km
         results(10) = plot_min_x_m * m2km
         results(11) = plot_max_x_m * m2km
         results(12) = plot_min_t_s
         results(13) = plot_max_t_s

         if (previous_model == 'yes') then
          results(14) = 1.
!        print*,'2.read_immodpg_config.f,previous_model=', results(14)
         else
          results(14) = 0.
!        print*,'2.read_immodpg_config.f,previous_model',results(14)
         end if

          if (new_model == 'yes') then
           results(15) = 1.
         else
           results(15) = 0.
         end if

         if (layer >= 0.0 ) then
           results(16) = real(layer)
!       print*,'1. read_immodpg_config.f,_layer:',layer
         else
          results(16) = -1.00
!      print*,'2.read_immodpg_config.f,layer:',layer
         end if

         results(17) = VtopNbot_factor;
         results(18) = Vincrement_mps * m2km;
         results(19) = thickness_increment_m * m2km;
!       result = 1
       close (unit=1)
!      if (answer == 'yes')

!      print(*), 'bingo=',result
!      end if

         else
!         print *, 'read_immodpg_file.f, err_msg=',err_msg
!         print *, 'read_immodpg_file.f, counter=',counter
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if
       else
        print *, 'read_immodpg_config.f,locked,try again,ready=',ready
!         go to 10
       end if
!       remove lock file
11      close (status='delete',unit=2,iostat=err_msg)
        if (err_msg.ne.0) then
         go to 11
         print *, 'read_immodpg_file.f, err_messg=',err_msg
        end if
!       print *, 'read_immodpg_file, result',result

      end subroutine read_immodpg_config

      subroutine write_yes_no_file(yes_or_no,outbound)
         implicit none
      character*5 yes_or_no
      character (len=255) :: outbound, outbound_locked
      character (len=30)  :: format1
      integer :: err_message, counter, ready

!      print *, 'write_yes_or_no_file, outbound is: ', outbound

      outbound_locked=trim(outbound)//"_locked"
      format1= "(A)"

  !      create a temporary, new, lock file
10     open(status='new',unit=28,file=outbound_locked,iostat=ready)
!       print *, 'read_option_file.f,inbound_locked iostat:',ready
!       if (ready.eq.17) print *, 'locked, try again'

      if (ready.eq.0) then
        open (2,file=trim(outbound),status='old',iostat=err_message)
!        counter = counter +1

!       check whether file opens data file
       if (err_message .eq. 0) then

        write (2,format1) trim(yes_or_no)
!        print *, 'write_yes_or_no_file, yes_or_no: ',trim(yes_or_no)
        close (unit=2)

       else
        print *, 'write_yes_no_file.f, err_message=',err_message

!         rest a little before trying again
!         call sleep(1)
         go to 10
        end if
       else
!         print *, 'read_option_file.f,locked, try again,read =',ready
          go to 10
       end if
 !       remove lock file
11      close (status='delete',unit=28,iostat=err_message)
        if (err_message.ne.0) then
         go to 11
         print *, 'write_yes_no_file.f, err_messg=',err_message
        end if

      end subroutine write_yes_no_file

      subroutine read_thickness_m_file(result,inbound)
         implicit none
!       read a configuration file

      real*4 :: result
      character (len=255) :: inbound, inbound_locked
      character (len=30) :: format1
      integer :: err_msg, ready

      inbound_locked=trim(inbound)//"_locked"
      format1= "(F5.1)"

!      print *,'read_thickness_m_file.f, inbound is:',trim(inbound)
!      in case inbound is of a different, but shorter length in main
!      create a temporary, new, lock file
10     open(status='new',unit=30,file=inbound_locked,iostat=ready)

       if (ready.eq.0) then
         open(unit=29,file=trim(inbound),status='old',iostat=err_msg)
 !       check whether file opens data file
         if (err_msg.eq.0) then

          read (29,format1) result
 !         print *, 'read_thickness_m_file.f, result',result
          close (unit=29)

         else
          print *,'read_thickness_m_file.f,locked,again,read=',ready
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if

!       remove lock file
11      close (status='delete',unit=30,iostat=err_msg)
        if (err_msg.ne.0) then
         go to 11
         print *, 'read_thickness_m_file.f, err_messg=',err_msg
        end if

       end if
!       print *, 'read_thickness_m_file, result',result
      end subroutine read_thickness_m_file

   	SUBROUTINE rdata(Amp, ntrmax, nsmax, ntr, ns,
     + Amp_min, Amp_max)     
! ****************************************************
	INTEGER*4 ntrmax,n,ntr,ns
	REAL*4 Amp(ntrmax,nsmax), Amp_min, Amp_max
       character*300 inbound_bin
       character*300 inbound_config
       character*40 base_file
       character*40 config_file
       character*255 set_DIR,get_DIR
       real*4        result(30)

      config_file  = "immodpg.config"
      config_file  = trim(config_file)

! define the different needed directories
      set_DIR = "IMMODPG"
      call Project_config(set_DIR,get_DIR)
!      print*,'immodpg.for,rdata,get_DIR:',get_DIR
      
!  define needed files
      inbound_config = trim(get_DIR)//"/"//config_file 
! config_file
!      print*,'immodpg.for,rdata,inbound_config:',inbound_config
!   read all the configuration parameters for immodpg
      call read_immodpg_config(base_file,result,inbound_config)

!      print*,'immodpg.for,rdata,base_file:',trim(base_file)
      
! define the different, needed directories
      set_DIR        = "DATA_SEISMIC_BIN"
      call Project_config(set_DIR,get_DIR)
      inbound_bin = trim(get_DIR)//"/"//trim(base_file)//'.bin'
!      print*,'1179immodpg.for,rdata,base_file:',inbound_bin
!      print*,'next line'
!      print*,'1218-immodpg.for,rdata,inbound_bin:',trim(inbound_bin)

! Read data File
      call read_bin_data (inbound_bin,ntrmax,nsmax,ntr,ns,Amp)

      Amp_min = 1e30
      Amp_max = -1e30
      do 20 i=1,ntr
      
         do 11 j=1,ns
            Amp_min = min(Amp(i,j),Amp_min)
            Amp_max = max(Amp(i,j),Amp_max)
 11      continue

 20   continue
!	print*, 'immodpg.for,rdata, Data min,max=',Amp_min,Amp_max
!	print*, 'immodpg.for, L 1197, rdata, finished reading data'

      return
      END ! of subroutine

      subroutine read_panNzoom_file(result,inbound)
         implicit none
!       read a configuration file

      integer :: result
      character (len=255) :: inbound, inbound_locked
      character (len=30) :: format1
      integer :: err_message, ready

      inbound_locked=trim(inbound)//"_locked"
      format1= "(I2)"

!      print *, 'read_layer_file, inbound is:', trim(inbound)
!      in case inbound is of a different, but shorter length in main

10     open(status='new',unit=26,file=inbound_locked,iostat=ready)

        if (ready.eq.0) then
         open(unit=27,file=trim(inbound),status='old',
     +    iostat=err_message)

!       check whether file opens data file
         if (err_message.eq.0) then

           read (27,format1) result
!          print *, 'read_panNzoom_file.f, result',result
          close (unit=31)

         else
!         print *, 'read_panNzoom_file.f, err_message=',err_message
!         print *, 'read_panNzoom_file.f, counter=',counter
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if
       else
         print *, 'lread_panNzoom_file.f,ocked, try again,read =',ready
         go to 10
       end if
!       remove lock file
11      close (status='delete',unit=26,iostat=err_message)
        if (err_message.ne.0) then
         go to 11
         print *, 'read_panNzoom_file.f, err_messg=',err_message
        end if
!       print *, 'read_panNzoom_file, result',result

      end subroutine read_panNzoom_file

	SUBROUTINE WRIMOD2(NL,VT,VB,DZ,VST,VSB,RHOT,RHOB)
	DIMENSION VT(*),VB(*),DZ(*),VST(*),VSB(*),RHOT(*),RHOB(*)
C
C WRITES VELOCITY MODEL ON THE SCREEN 
C
	ICH = 6
	WRITE(ICH,50)
	WRITE(ICH,100)
	WRITE(ICH,50)
C
	A1=0.
	A2=0.
	DO 20 I=1,NL
	A1=A1+DZ(I)
C COMPUTES 2-WAY TRAVELTIME ASSUMING EITHER CONSTANT VELOCITY OR
C CONSTANT VELOCITY GRADIENT LAYERS.
C
	IF(VT(I).EQ.VB(I)) THEN
		A2=A2+2.*DZ(I)/VT(I)
	ELSE
		A2=A2+2.*DZ(I)*ALOG(VB(I)/VT(I))/(VB(I)-VT(I))
	ENDIF
C
  	WRITE(ICH,200) I,VT(I),VB(I),DZ(I),A1,A2,VST(I),VSB(I),
     +  RHOT(I),RHOB(I)
20	CONTINUE
	WRITE(ICH,50)
C
50	FORMAT('')
100	FORMAT(3X,'#',1X,'VTOP(km/s)','VBOTT',X,'DZ',1X,'(km)',1X,'ZBOTT',
     +  3X,'TWTT(s)',3X,'VSTOP',2X,'VSBOTT',4X,'RHOT',4X,'RHOB')
200	FORMAT(I4,11F8.5)
C
	RETURN
        END

	SUBROUTINE TXPR(NL,VT,VB,DZ,PMIN,PMAX,DP,IR,MULTIN,
     &  NTP,ILA,PPP,XXX,TT)
C ** RAY TRACING MAIN LOGIC **
	DIMENSION VT(*),VB(*),DZ(*),XXX(*),TT(*)
	DIMENSION IR(*),MULTIN(*),ILA(*),PPP(*)
C
	NTP=0
	NL1=NL
	P=PMIN
45	X=0.
	T=0.
C
	DO 5 I=1,NL1
	M=MULTIN(I)
	I1=I+1
	ABP=ABS(P)
	CALL TXGRD(ABP,VT(I),VB(I),DZ(I),DT,DX,IN)
	IF(IN.EQ.0) GO TO 50
	IF(P.LT.0.0) DX=-DX
	X=X+DX*M
	T=T+DT*M
C ***********************************************
	IF(IN.EQ.1.OR.IR(I).EQ.1) THEN
	  NTP=NTP+1
	  XXX(NTP)=X
	  TT(NTP)=T
	  PPP(NTP)=P
	  ILA(NTP) = I !**POST CRITICAL REFLECTION
C
	  IF(IN.EQ.1) THEN
        	GO TO 62
	  ELSE
		A2=1./VT(I1)
		IF(ABP.LT.A2) ILA(NTP) = -I !**PRE CRITICAL REFLECTION
	  ENDIF
C
	ENDIF
5	CONTINUE
	GO TO 62
50	NL1=I-1
62	P=P+DP
   	IF(P.GT.PMAX) GO TO 65
	GO TO 45
C **** COMPUTATION  FINISHED ****
65	CONTINUE
	RETURN
	END

      subroutine read_option_file(result,inbound)
         implicit none

!       read option file with an integer number

      character (len=30) :: format1
      character (len=255) :: inbound, inbound_locked
      integer :: err_message, counter, ready
      integer :: result

      inbound_locked=trim(inbound)//"_locked"
      format1= "(I3)"

!      print *, 'read_option_file, inbound is:', trim(inbound)
!      in case inbound is of a different, but shorter length in main
!      inbound=inbound

!      open(unit=28,file=trim(inbound),status='old')
!       read (28,format1) result
!!       print *, 'read_option_file, result',result
!       close (unit=28)

!      create a temporary, new, lock file
10     open(status='new',unit=28,file=inbound_locked,iostat=ready)
!       print *, 'read_option_file.f,inbound_locked iostat:',ready
!       if (ready.eq.17) print *, 'locked, try again'
       if (ready.eq.0) then
        open(unit=29,file=trim(inbound),status='old',iostat=err_message)
!        counter = counter +1

!       check whether file opens data file
        if (err_message.eq.0) then

          read (29,format1) result

!        print *, 'read_option_file.f, result',result
         close (unit=29)

        else
!         print *, 'read_option_file.f, err_message=',err_message
!         print *, 'read_option_file.f, counter=',counter

!         rest a little before trying again
!         call sleep(1)
         go to 10
        end if
       else
!         print *, 'read_option_file.f,locked, try again,read =',ready
         go to 10
       end if
!       remove lock file
11      close (status='delete',unit=28,iostat=err_message)
        if (err_message.ne.0) then
         go to 11
!         print *, 'read_option_file.f, err_messg=',err_message
        end if

      end subroutine read_option_file

      subroutine read_bin_data(inbound_bin,ntrmax,nsmax,ntr,ns,Amp)
        implicit none
        
!       read_bin_data reads a fortran-style binary seismic image

       character (len=300) :: inbound_bin, inbound, inbound_locked
       integer*4      :: ntrmax,nsmax,ntr,ns,k,i
       real*4         :: Amp(ntrmax,nsmax)
       integer        :: err_msg, counter, ready

!      trim end and adjustl start of empty spaces
       inbound=trim(adjustl(inbound_bin))
!      print *, 'read_bin_data, inbound_bin is:',trim(inbound)bin),'--'
!      print *, 'read_bin_data, next line:'
       inbound_locked=trim(inbound_bin)//"_locked"
!      print *, 'read_bin_data, inbound_locked is:',trim(inbound_locked),&

!      create a temporary, new, lock file
10     open(status='new',unit=31,file=inbound_locked,iostat=ready)

       if (ready.eq.0) then
       
 20      open(UNIT=21,FILE=inbound_bin,STATUS='OLD',IOSTAT=err_msg, &
         FORM='UNFORMATTED',access='stream')
         counter = counter +1
!        print *, 'L27.read_bin_data.f, err_msg=',err_msg
         
!        check whether file opens data file
         if (err_msg.eq.0) then
!         print *, 'L34.read_bin_data.f,unlocked, err_msg=',err_msg
           
          k=1
          do      
! 120      read (unit=21) (Amp(k,i), i=1,ns)

           i=1
           do 
120         read (unit=21) Amp(k,i)

 !            print*,'k, i,ntr, ns,Amp(k-1,i-1)',k,i,ntr,ns,Amp(k-1,i-1)
 !            i = i+1
             if(i.GE.ns) goto 50
           enddo
          
50         k=k+1	  
           if(k.GE.ntr) go to 125
          enddo
          
 125      close (unit=21)

         else
!        print *, 'read_bin_data.f, err_msg=',err_msg
!        print *, 'L49 read_bin_data.f, can not open bin file=',counter

!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if
        
       else
         print *, 'L57. read_bin_data.f,locked, try again,ready=',ready
 !        print *, '3.read_bin_data.f, err_messg=',err_msg
         go to 10
       end if
       
!      remove lock file
11     close (status='delete',unit=31,iostat=err_msg)
!          print *, '4.read_bin_data.f, err_messg=',err_msg

       if (err_msg.ne.0) then
       
        go to 11
!        print *, '5.read_bin_data.f, err_messg=',err_msg
 
       end if
         
!       print *, 'read_bin_data, finished'

      end subroutine read_bin_data

c
c Calculo de curvas camino-tiempo para modelos formados por una
c combinacion de capas planas homogeneas o con gradiente de
c velocidad constante. Fuente y receptor en 1ra capa; default
c es que ambos esten en superficie.
c
        integer   nlmax,npmax,npamax,ntrmax,nsmax,ntr,ns
        parameter (nlmax=50,npmax=60000,npamax=60000)
        parameter (ntrmax=1024,nsmax=8192)
        parameter (nxymax=1000)
        real      f(ntrmax,nsmax)
        real      fmin,fmax
        dimension IR(nlmax-1),VT(nlmax),VB(nlmax),DZ(nlmax)
        dimension VST(nlmax),VSB(nlmax),RHOT(nlmax),RHOB(nlmax)
        dimension va(2*nlmax),za(2*nlmax)
        dimension multin(nlmax)
        dimension ILA(npmax),P(npmax),X(npmax),T(npmax)
        dimension xa1(npamax),xa2(npamax),xa3(npamax),xa4(npamax)
        dimension xa5(npamax)
        dimension xdig(nxymax),tdig(nxymax)
        dimension xdigp(nxymax),tdigp(nxymax)
        dimension xdign(nxymax),tdign(nxymax),axdign(nxymax)
        character val,finxy*40
        logical   flag
c
c DEFAULT PARAMETERS
c
        sdepth = 0.0
        rdepth = 0.0
        pmin   = 0.0
        pmax   = 8.0
        dp     = 0.0006
        vmf    = 1./sqrt(3.)
        rv     = 2.0
        xmin   = -0.2
        xmax   = 0.3
        tmin   = 0.0
        tmax   = 0.2
        lch    = 1
        icolor = 0
        xinc   = 0.1
        iac    = 0
        iout   = 35
        datadx = 0.005
        datax1 = -0.185
c       datadt = 0.005
        datat1 = 0.0
        flag   = .false.
        idred  = 0
        idrdtr = 0
        idrxy  = 0
        clip   = 0.9
        idpof  = 0
c       psld   = 0.0
c
        do i=1,nlmax
                multin(i) = 1
        enddo
c
c ********  Program Message *********
c
        call messa
        write(*,*) ' '
        write(*,*) 'Modeling of Traveltime (T-X) Curves'
        write(*,*) ' '
        write(*,*) 'LDGO , 1984-1989'
        write(*,*) 'BOIGM, 1993'
        write(*,*) 'Depto. de Geofisica, U. de Chile, 1996-**'
        write(*,*) ' '
        write(*,*) 'Computations are carried out for a model consisting'
        write(*,*) 'of a mixture of horizontal constant velocity, and'
        write(*,*) 'constant vel. gradient layers.  Low velocity zones'
        write(*,*) 'can be included. Each layer is specified by its top'
        write(*,*) 'and bottom velocity.  Rays are traced using'
        write(*,*) 'equispaced ray parameters.'
        write(*,*) ' '
        write(*,*) 'Data traces are presented in wiggle plot mode'
        write(*,*) ' '
c
c Read digitized X-T pairs, and separate them by positive (p)
c and negative (n) offsets.
c
        call read_par_i4('1- Read digitized X-T pairs, 0- No',idrxy)
        if(idrxy.eq.1) then
c
           finxy = '???'
           call read_datxy(xdig,tdig,ndxy,finxy,21,1)
c
           ndxyp = 0
           ndxyn = 0
           do ixy = 1,ndxy
             if(xdig(ixy).ge.0.0) then
                     ndxyp = ndxyp + 1
                     xdigp(ndxyp) = xdig(ixy)
                     tdigp(ndxyp) = tdig(ixy)
             else
                     ndxyn = ndxyn + 1
                     xdign(ndxyn)  = xdig(ixy)
                     axdign(ndxyn) =-xdig(ixy)
                     tdign(ndxyn)  = tdig(ixy)
             endif

           enddo
           call read_par_i4('0- Consider abs(offsets), 1- No',idpof)
c
        endif
c
c Read data traces
c
        call read_par_i4('1- Read data traces, 0- No',idrdtr)
        if(idrdtr.eq.1) then
          call rdata(f,ntrmax,nsmax,ntr,ns,datadt,fmin,fmax)
c
c
          call read_par_r4('Time of 1st data sample (sec) ?',datat1)
          call read_par_r4('Dist. of trace 1 along line (km)?',datax1)
c         call read_par_r4('Perpendicular shot-line dist. (km)?',psld)
c         psld2 = psld * psld
          call read_par_r4('Dist. between geophones (km) ?',datadx)
          gain = 10 * datadx / fmax
          call read_par_r4('Gain for data?',gain)
c
        endif
c
15      continue
c
c ***** SOURCE AND RECEIVER DEPTH DEFINITION *****
c
        call read_par_r4('SOURCE DEPTH (KM) ?',SDEPTH)
        call read_par_r4('RECEIVER DEPTH (KM) ?',RDEPTH)
c
c **** PARAMETERS FOR THE X-T PLOT  ****
c
        write(*,*) 'TO DEFINE  PLOTTING AREA ENTER : '
        write(*,*) ' '
        rvinv=0.
        call read_par_r4('Reducing Velocity (km/s),(0-For none)',rv)
        if (rv.eq.0.) go to 40
        rvinv=1./rv
40      continue
        if(idrdtr.eq.1) then
        call read_par_i4('1-Traces are red. by this vel., 0-No',idred)
        endif
c
        call read_par_r4('MINIMUN DISTANCE (KM)?',xmin)
        call read_par_r4('MAXIMUN DISTANCE (KM)?',xmax)
        call read_par_r4('MINIMUN TIME (SEC)?',tmin)
        call read_par_r4('MAXIMUN TIME (SEC)?',tmax)
c **** RE-CHECK PARAMETERS ****
        ID=0
        call read_par_i4('1- RECHECK PARAMETERS,0- NO',ID)
        if(ID.eq.1) go to 15
c
c
        rvinvd = 0.0
        if(idred.eq.0) rvinvd = rvinv
c *******************
c *****    READ VELOCITY DEPTH MODEL  ******
c
        call READMMOD(VT,VB,DZ,VST,VSB,RHOT,RHOB,nl)
c
        call read_par_i4('Working layer number ?',lch)
                if(lch.lt.1)   lch = 1
                if(lch.gt.nl)  lch = nl
c
c ***************** Open X-T Window ****************
c
        call pgbegin(0,'?',1,1)
c       call pgpaper(12.0,8.5/11.0)
c       call pgpaper(17.0,0.6)
        call pgpaper(14.0,0.6)
        call pgask(flag)
************************************
c
10      continue
c
c Check for vt-vb too small.
c
        A3 = 0.001
c
        do 20 i = 1, nl
20      if(ABS(VT(I)-VB(I)).le.A3) vb(i) = vt(i)
c
c Reflections at the bottom of layers decided automatically
c based on velocity discontinuities
c
        do 34 I=1,nl-1
        IR(I)=0
34      if(ABS(VT(I+1)-VB(I)).GT.A3) IR(I)=1
        IR(nl) = 0  !** No reflection at the bottom of model
c
c *** COMPUTATIONS ***
c
        DZ1TEM=DZ(1)
        DZ(1)=DZ(1)-(SDEPTH+RDEPTH)/2. ! Correct only if 1rst layer
c                                        is a constant vel. layer. 
        call txpr(nl,VT,VB,DZ,PMIN,PMAX,DP,IR,multin,ntp,ILA,P,X,T)
        DZ(1)=DZ1TEM
c       write(*,*) 'total # of computed points ',ntp
c
c *** PLOTTING ***
c
55      continue
c       call pgvport(0.1,0.9,0.1,0.9)
        call pgvport(0.075,1.0,0.08,0.925)
        call pgwindow(xmin,xmax,tmax,tmin)
        call pgbox('BCTN',0.0,0,'BCTN',0.0,0)
        call pglabel('X(km)','T - X/Vred (s)',
c       call pglabel('X(km)','T - X/8.0 (seg)',
     +  'Curvas camino-tiempo (X-T), Ondas P, Modelo 1-D')
c     +  'Primary P-wave T-X Curves, 1-D Model')
c
        if(idrdtr.eq.1) then
                call pgsci(1)
                do j=1,ntr
                 xline = datax1 + (j-1) * datadx
c                 datax = sqrt(psld2 + xline*xline)
                 datax = xline
                 a4    = datax + clip * datadx
                 a5    = datax - clip * datadx
                 do i=1,ns
                   a3  = f(j,i)
                   xa1(i) = datax  +  gain * a3
                   if(xa1(i).gt.a4) xa1(i) = a4
                   if(xa1(i).lt.a5) xa1(i) = a5
                   xa3(i) = xa1(i)
                   if(a3.lt.0.0)    xa3(i) = datax
                   xa2(i) = datat1 + (i-1)*datadt - abs(datax)*rvinvd
                 enddo
c
                 call pgline(ns,xa1,xa2)
                 xa3(1)  = datax
                 xa3(ns) = datax
c pgsci(1) selecciona blanco (negro en papel) para rellenar trazas
c pgsci(3) relleno en verde
                 call pgsci(3)
                 call pgpolyev(ns,xa3,xa2)
c                call pgpoly(ns,xa3,xa2)
                 call pgsci(1)
                enddo
        endif
c
        do 140 j=1,lch
        nplj = 0
        do 120 i=1,ntp
c ** SELECT LAYER J **
        if(ABS(ILA(I)).NE.J) go to 120
        nplj = nplj+1
        xa1(nplj)  =   X(I)
        xa5(nplj)  =  -X(I)
        xa2(nplj)  =   T(I) - X(I) * rvinv !** RED. TIME
        xa3(nplj)  =   P(I)
        xa4(nplj)  =   T(I) - X(I) *  P(I) !** TAU
120     continue
        if(nplj.eq.0) go to 140
c
c ** PLOT LAYER J **
c
        icolor = icolor + 1
        if(icolor.gt.15) icolor = 1
        call pgsci(icolor)
c       call pgsci(3)
c
c ** X - T Plot **
c
        call pgline(nplj,xa1, xa2)
        call pgline(nplj,xa5, xa2)
c
c ** TAU - P Plot **
c
c       call gks$polyline(nplj, xa3, xa4)
c
140     continue
c
c Draw digitized X-T data
c
        if(idrxy.eq.1) then
c          Positive offsets branch
           if(ndxyp.gt.0) then
             do ixy = 1,ndxyp
               xa2(ixy) = tdigp(ixy) - xdigp(ixy) * rvinv
             enddo
             call pgsci(3)
c            call pgsci(2)
             call pgpoint(ndxyp,xdigp,xa2,9)
           endif
c          Negative offsets branch
           if(ndxyn.gt.0) then
             do ixy = 1,ndxyn 
               xa2(ixy) = tdign(ixy) - axdign(ixy) * rvinv
             enddo
             call pgsci(2)
             if(idpof.eq.0) then
               call pgpoint(ndxyn,axdign,xa2,9)
             else
               call pgpoint(ndxyn,xdign,xa2,9)
             endif
           endif
c
        endif
c
c Draw velocity model
c
c ****** descomentar para trabajo con OBS  ***
c       dz(1) = 2.0 * dz(1)
c ***********************
        a1 =  0.0
        a2 = -1.0
        do 145 i = 1,lch
                k = 2*i - 1
                va(k) = vt(i)
                if(vt(i).gt.a2) a2=vt(i)
                za(k) = a1
                va(k+1) = vb(i)
                if(vb(i).gt.a2) a2=vb(i)
                a1 = a1 + dz(i)
                za(k+1) = a1
145     continue
c ****** descomentar para trabajo con OBS  ***
c       dz(1) = dz(1)/2.0
c ***********************
c
        call pgsci(1)
        call pgvport(0.88,0.98,0.2,0.8)
        call pgwindow(0.0,a2,a1,0.0)
        call pgbox('BCTN',0.0,0,'BCNST',0.0,0)
        call pglabel('V(km/s)','Z(km)','')
c
c       call pgslw(5)
        call pgline(2*lch,va,za)
c       call pgslw(1)
c
150     continue
c
        write(*,*)''
        write(*,*)'*** CHANGE : *****************************'
        write(*,*)'0-  Working layer (Now is LAYER ',lch,')'
        write(*,500) VT(lch),VB(lch)
        write(*,502) DZ(lch)
        write(*,*)'5-  VTOP and overlying VBOT,  6-  VBOT and underlying
     + VTOP'
        write(*,504) DP
        write(*,503) xinc
        write(*,*)'******************************************'
        write(*,*)'8-  Zoom and move image, 11- Multiply all Velocities
     + by a constant'   
        write(*,*)'12- or larger to END'
c
        call read_par_i4('Option number ?',iac)
c
        if(iac.gt.11) go to 255
c
        if(iac.eq.7) then
                call read_par_r4('New increment (km or km/s) ??',xinc)
                go to 150
        endif
c
        if(iac.eq.8) then
                call pgzoom(xmin,xmax,tmin,tmax)
                icolor = 0
                call pgpage
                call pgsci(1)
                go to 55
        endif
c
c *** Options that require recompute X-T curves ***
c
        if(iac.eq.0) then
                lch = lch + 1
                call read_par_i4('Layer Number ??',lch)
                if(lch.lt.1)   lch = 1
                if(lch.gt.nl)  lch = nl
        endif
c
        if(iac.ge.1.and.iac.le.6) then
                write(*,*) ''
                write(*,*) 'RETURN to increase,  - to decrease'
                read(*,'(a)') val
c
                a1 = xinc
                if (val.eq.'-') a1 = -xinc
c
                if(iac.eq.1) VT(lch) = VT(lch) + a1
                if(iac.eq.2) VB(lch) = VB(lch) + a1
                if(iac.eq.3) DZ(lch) = DZ(lch) + a1
c
                if(iac.eq.4) then
                        VT(lch) = VT(lch) + a1
                        VB(lch) = VB(lch) + a1
                endif
c
                if(iac.eq.5) then
                        VT(lch) = VT(lch) + a1
                        if(lch.gt.1) VB(lch-1) = VB(lch-1) + a1
                endif
c
                if(iac.eq.6) then
                        if(lch.lt.nl) VT(lch+1) = VT(lch+1) + a1
                        VB(lch) = VB(lch) + a1
                endif
        endif
c
        if(iac.eq.9) then
                call read_par_r4('New gain ??',gain)
        endif
c
        if(iac.eq.10) then
                call read_par_r4('New dp (s/km) ??',dp)
        endif
c
        if(iac.eq.11) then
                call read_par_r4('Multiplicative constant ??',vmf)
                do i = 1,nl
                        VT(i) = vmf * VT(i)
                        VB(i) = vmf * VB(i)
                enddo 
        endif
c
c **************************
c
        icolor = 0
        call pgpage
        call pgsci(1)
        go to  10
c
255     continue
c
c write modified model to terminal
c
        write(*,*) ' '
        write(*,*) 'MODIFIED MODEL:'
        call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
c
c write modified model to file mmodpg.out
c
        OPEN(UNIT=IOUT,FILE='mmodpg.out',STATUS='UNKNOWN',
     +  FORM='UNFORMATTED')
        do K=1,NL+1
                write(IOUT) VT(K),VB(K),DZ(K),
     +          VST(K),VSB(K),RHOT(K),RHOB(K)
        enddo
        CLOSE(UNIT=IOUT)
c
        write(*,*) 'This model has been written to file:'
        write(*,*) '***     mmodpg.out     ***'
c
        call pgend
500     format(' 1-  VTOP = ',f6.3,',            2-  VBOT = ',f6.3,' (km
     +/s)')
502     format(' 3-  DZ   = ',f7.4,' (km)',',      4-  VTOP and VBOT')
503     format(' 7-  Increment = ',f7.4,' (km or km/s)')
504     format(' 9-  Gain for data,            10- DP = ',f9.6,
     +' (s/km)')
        end
c
c ****************************************************
c
        SUBROUTINE rdata(f, m, n, ntr, ns, datadt, fmin, fmax)
        INTEGER m,n,ntr,ns,idtusec
        REAL f(m,m), fmin, fmax
        CHARACTER*40 FIN
        LOGICAL EX
c
c Read data parameters
c
        iin=26
        OPEN(UNIT=iin,FILE='parmmod',STATUS='OLD')
        read(iin,*) ntr,ns,idtusec
        close(iin)
        datadt = float(idtusec) * 1e-6
c
c115    write(*,*) 'INPUT DATA FILE NAME ?? '
c	READ(5,'(A)') FIN
c       INQUIRE(FILE=FIN,EXIST=EX)
c	if(.NOT.EX) then
c	write(*,*)'FILE DOES NOT EXIST, TRY AGAIN WITH A NEW NAME'
c	go to 115
c	endif
c
c	OPEN(UNIT=iin,FILE=FIN,STATUS='OLD',FORM='UNFORMATTED')
c
c Read data File
c
        OPEN(UNIT=iin,FILE='datammod',STATUS='OLD',FORM='UNFORMATTED')
        k=1
120     READ(iin) (f(k,i), i=1,ns)
        if(k.GE.ntr) go to 125
        k=k+1
        go to 120
125     CLOSE(UNIT=iin)
c
      fmin = 1e30
      fmax = -1e30
      do 20 i=1,ntr
         do 10 j=1,ns
            fmin = min(f(i,j),fmin)
            fmax = max(f(i,j),fmax)
 10      continue
 20   continue
c
        write(*,*) 'Data min, max  = ',fmin,fmax
        write(*,*)
c
      END
c
c ************************************************
c
        subroutine read_datxy(x,y,n,fin,iin,iwrit)
c
c Reads file containing (x,y) pairs and an arbitrary number of comment lines
c in between.  The (x,y) pairs are returned in arrays x and y. The
c comment lines are written on the terminal.
c
c n     = number of (x,y) pairs in the file (output).
c
c fin   = Default input file name (input)
c iin   = reading input unit (input).
c iwrit = if iwrit.eq.1, (x,y) pairs are written on screen (input).  
c
        dimension x(*),y(*)
        character*40 fin
        character*40 comment
        LOGICAL EX
c
c  ********* read input file *********
c
c Check for default file "fin".  If file does not exist, then ask for
c a file name
c
c       write(*,*) fin
        go to 117
115     write(*,*) 'Input File Name ?? '
        READ(*,'(A)') fin
117     INQUIRE(FILE=fin,EXIST=EX)
        IF(.NOT.EX) THEN
        write(*,*) 'There is no trace defined'
        GO TO 115
        ENDIF
        OPEN(UNIT=iin,FILE=fin,STATUS='OLD')
c
        n = 1
        write(*,*)
120     continue
        READ(iin,'(a)',end=170,err = 150) comment
        read(comment,*,err = 150) xa,ya
        x(n) = xa
        y(n) = ya
        n = n + 1
        go to 120
150     continue
        write(*,'(a)') comment
        go to 120
170     continue
        close(iin)
        n = n - 1
c ************************************************************
        if(n.ge.1) then
           if(iwrit.eq.1) then
                write(*,*) '** Digitized traveltime data ** '
                write(*,*) ' '
                write(*,*) '            X(km)          T(sec)'
                write(*,*) ' '
                do 180 i = 1,n
180             write(*,300) i,x(i),y(i)
                write(*,*) ' '
           endif
        else
        write(*,*) '* There is no line containing data in this file *'
        endif
300     format(i5,2f15.6)
        return
        end
c ******************************************

c Zoom in and out, and move picture around
c
	subroutine pgzoom(xmin,xmax,ymin,ymax)
c
	character val
c
	write(*,*)
	write(*,*) '** Move cursor into the graphic screen **'
	write(*,*)
	write(*,*) 'i - zoom in,          o - zoom out'
	write(*,*) 'k - move image up,    j - move image down'
	write(*,*) 'l - move image right, h - move image left'
	write(*,*)
	write(*,*) '** Press any other key to leave **'
	write(*,*)
c
	read(*,'(a)') val
c
c Zoom in
	  if (val.eq.'i') then
	    dx = (xmax - xmin)/10
	    dy = (ymax - ymin)/10
c	    xmin = xmin + dx
c           xmax = xmax - dx
            xmax = xmax - 2.0*dx
            ymin = ymin + dy
            ymax = ymax - dy
	  endif
c Zoom out
	  if (val.eq.'o') then
	    dx = -(xmax - xmin)/8
	    dy = -(ymax - ymin)/8
	    xmin = xmin + dx
            xmax = xmax - dx
            ymin = ymin + dy
            ymax = ymax - dy
	  endif
c Move image down
	  if (val.eq.'j') then
            dy = (ymax - ymin)/10
	    ymin = ymin - dy
	    ymax = ymax - dy
          endif
c Move image up
	  if (val.eq.'k') then
            dy = (ymax - ymin)/10
	    ymin = ymin + dy
            ymax = ymax + dy
          endif
c Move image to the right
	  if (val.eq.'l') then
            dx = (xmax - xmin)/10
            xmin = xmin - dx
            xmax = xmax - dx
          endif
c Move image to the left
          if (val.eq.'h') then
	    dx = (xmax - xmin)/10
            xmin = xmin + dx
            xmax = xmax + dx
          endif
c
	return
	end

      subroutine stdsleep
!program stdsleep
! uses unistd.h for Fortran standard compliant sleep.
! sleep() is a GNU extension, not standard Fortran.
      use, intrinsic:: iso_c_binding, only: c_int
      implicit none

      interface
      
       subroutine usleep(us) bind (C)
        import c_int
        integer(c_int), value :: us
       end subroutine usleep
       
      end interface



      integer(c_int), parameter :: us=500000

      print *,'sleeping for ',us/1000,' milliseconds.'
      call usleep(us)
      print *,'what a nice nap. Goodbye.'
      
     end subroutine stdsleep

      subroutine read_yes_no_file(result,inbound)
         implicit none
!       read a configuration file

      logical :: result
      character (len=255) :: inbound, inbound_locked
      character (len=30)  :: format1
      character (len=80)  :: change
      integer :: err_message, counter, ready

      inbound_locked=trim(inbound)//"_locked"
      format1= "(A)"
!      in case definition in main is slightly different
       change = 'no'
!      print *, 'read_yes_no_file.f,inbound is:',inbound
!      in case inbound is of a different, but shorter length in main
!      inbound=inbound

!      create a temporary, new, lock file
10     open(status='new',unit=11,file=inbound_locked,iostat=ready)
!        print *, 'read_yes_no_file.f,inbound_locked, unlocked:',ready

       if (ready.eq.0) then
        open(unit=12,file=inbound,status='old',iostat=err_message)
!        counter = counter +1

!       check whether file opens data file
        if (err_message.eq.0) then

         read (12,format1) change

         if (change == 'yes') then
          result = .TRUE.
         else
          result = .FALSE.
         end if

!        print *, 'read_yes_no_file.f, change:',change
!        print *, 'read_yes_no_file.f, result',result
         close (unit=12)

        else
!         print *, 'read_yes_no_file.f, err_message=',err_message
!         print *, 'read_yes_no_file.f, counter=',counter
!         rest a little before trying again
!         call sleep(1)
         go to 10
        end if
       else
!        print *, 'read_yes_no_file.f,locked, try again,read =',ready
        go to 10
       end if

!       remove lock file
11     close (status='delete',unit=11,iostat=err_message)
        if (err_message.ne.0) then
         go to 11
!         print *, 'read_yes_no_file.f, err_messg=',err_message
        end if

      end subroutine read_yes_no_file

c Zoom in and out, and Move picture around
c
	subroutine moveNzoom(xmin,xmax,ymin,ymax,value)
c
	integer*2 value
	integer*2 zoom_plus, zoom_minus
	integer*2 move_image_left, move_image_right, move_image_up, move_image_down

!	definitions
	move_image_up     = 81
	move_image_down   = 83
	move_image_right  = 82
	move_image_left   = 84
	zoom_plus  = 85
	zoom_minus = 86
c
!	write(*,*)
!	write(*,*) '** move_image cursor into the graphic screen **'
!	write(*,*)
!	write(*,*) 'i - zoom in,          o - zoom out'
!	write(*,*) 'k - move image up,    j - move image down'
!	write(*,*) 'l - move image right, h - move image left'
!	write(*,*)
!	write(*,*) '** Press any other key to leave **'
!	write(*,*)
c
!	read(*,'(a)') val
c

c Zoom in
	  if (value.eq.zoom_plus) then
	    dx = (xmax - xmin)/10
	    dy = (ymax - ymin)/10
c	    xmin = xmin + dx
c           xmax = xmax - dx
            xmax = xmax - 2.0*dx
            ymin = ymin + dy
            ymax = ymax - dy
	  endif
c Zoom out
	  if (value.eq.zoom_minus) then
	    dx = -(xmax - xmin)/8
	    dy = -(ymax - ymin)/8
	    xmin = xmin + dx
            xmax = xmax - dx
            ymin = ymin + dy
            ymax = ymax - dy
	  endif
c Move image down
	  if (value.eq.move_image_down) then
            dy = (ymax - ymin)/10
	    ymin = ymin - dy
	    ymax = ymax - dy!       format1= "(I2)"
          endif
c Move image up
	  if (value.eq.move_image_up) then
            dy = (ymax - ymin)/10
	    ymin = ymin + dy
            ymax = ymax + dy
          endif
c Move image to the right
	  if (value.eq.move_image_right) then
            dx = (xmax - xmin)/10
            xmin = xmin - dx
            xmax = xmax - dx
          endif
c Move image to the left
          if (value.eq.move_image_left) then
	    dx = (xmax - xmin)/10
            xmin = xmin + dx
            xmax = xmax + dx
          endif
c
	return
	end

C Version de PGPOLY donde he modificado el parametro
C MAXOUT del valor 1000 que trae originalmente, a 8192.
C Esto posibilita el graficado de trazas de hasta 8192
C muestras que no es posible con la version original de
C la libreria pgplot.
C
C*PGPOLY -- draw a polygon, using fill-area attributes
C%void cpgpoly(int n, const float *xpts, const float *ypts);
C+
      SUBROUTINE PGPOLYEV (N, XPTS, YPTS)
      INTEGER N
      REAL XPTS(*), YPTS(*)
C
C Fill-area primitive routine: shade the interior of a closed
C polygon in the current window.  The action of this routine depends
C on the setting of the Fill-Area Style attribute (see PGSFS).
C The polygon is clipped at the edge of the
C window. The pen position is changed to (XPTS(1),YPTS(1)) in world
C coordinates (if N > 1).  If the polygon is not convex, a point is
C assumed to lie inside the polygon if a straight line drawn to
C infinity intersects and odd number of the polygon's edges.
C
C Arguments:
C  N      (input)  : number of points defining the polygon; the
C                    line consists of N straight-line segments,
C                    joining points 1 to 2, 2 to 3,... N-1 to N, N to 1.
C                    N should be greater than 2 (if it is 2 or less,
C                    nothing will be drawn).
C  XPTS   (input)  : world x-coordinates of the vertices.
C  YPTS   (input)  : world y-coordinates of the vertices.
C                    Note: the dimension of arrays XPTS and YPTS must be
C                    greater than or equal to N.
C--
C 21-Nov-1983 - [TJP].
C 16-Jul-1984 - revised to shade polygon with GRFA [TJP].
C 21-Oct-1985 - test PGFAS [TJP].
C 25-Nov-1994 - implement clipping [TJP].
C 13-Jan-1994 - fix bug in clipping [TJP].
C  6-Mar-1995 - add support for fill styles 3 and 4 [TJP].
C 12-Sep-1995 - fix another bug in clipping [TJP].
C-----------------------------------------------------------------------
      INTEGER MAXOUT
      PARAMETER (MAXOUT=8192)
      LOGICAL CLIP
      INTEGER I, N1, N2, N3, N4
      REAL    QX(MAXOUT), QY(MAXOUT), RX(MAXOUT), RY(MAXOUT)
      REAL    XL, XH, YL, YH
      LOGICAL PGNOTO
      INCLUDE 'pgplot.inc'
C
      IF (PGNOTO('PGPOLY')) RETURN
      IF (N.LT.1) RETURN
C
C Outline style, or polygon of less than 3 vertices.
C
      IF (PGFAS(PGID).EQ.2 .OR. N.LT.3) THEN
         CALL PGBBUF
         CALL GRMOVA(XPTS(N),YPTS(N))
         DO 10 I=1,N
            CALL GRLINA(XPTS(I),YPTS(I))
 10      CONTINUE
C
C Hatched style.
C
      ELSE IF (PGFAS(PGID).EQ.3) THEN
         CALL PGBBUF
         CALL PGHTCH(N, XPTS, YPTS, 0.0)
      ELSE IF (PGFAS(PGID).EQ.4) THEN
         CALL PGBBUF
         CALL PGHTCH(N, XPTS, YPTS, 0.0)
         CALL PGHTCH(N, XPTS, YPTS, 90.0)
      ELSE
C     
C Test whether polygon lies completely in the window.
C     
         CLIP = .FALSE.
         XL = MIN(PGXBLC(PGID),PGXTRC(PGID))
         XH = MAX(PGXBLC(PGID),PGXTRC(PGID))
         YL = MIN(PGYBLC(PGID),PGYTRC(PGID))
         YH = MAX(PGYBLC(PGID),PGYTRC(PGID))
         DO 20 I=1,N
            IF (XPTS(I).LT.XL .OR. XPTS(I).GT.XH .OR.
     :           YPTS(I).LT.YL .OR. YPTS(I).GT.YH) THEN
               CLIP = .TRUE.
               GOTO 30
            END IF
 20      CONTINUE
 30      CONTINUE
C     
C Filled style, no clipping required.
C     
         CALL PGBBUF
         IF (.NOT.CLIP) THEN
            CALL GRFA(N,XPTS,YPTS)
C     
C Filled style, clipping required: the vertices of the clipped
C polygon are put in temporary arrays QX,QY, RX, RY.
C     
         ELSE
            CALL GRPOCL(N,  XPTS, YPTS, 1, XL, MAXOUT, N1, QX, QY)
            IF (N1.GT.MAXOUT) GOTO 40
            IF (N1.LT.3) GOTO 50
            CALL GRPOCL(N1, QX,   QY,   2, XH, MAXOUT, N2, RX, RY)
            IF (N2.GT.MAXOUT) GOTO 40
            IF (N2.LT.3) GOTO 50
            CALL GRPOCL(N2, RX,   RY,   3, YL, MAXOUT, N3, QX, QY)
            IF (N3.GT.MAXOUT) GOTO 40
            IF (N3.LT.3) GOTO 50
            CALL GRPOCL(N3, QX,   QY,   4, YH, MAXOUT, N4, RX, RY)
            IF (N4.GT.MAXOUT) GOTO 40
            IF (N4.GT.0) CALL GRFA(N4,RX,RY)
            GOTO 50
 40         CALL GRWARN('PGPOLY: polygon is too complex')
 50         CONTINUE
         END IF
      END IF
C
C Set the current pen position.
C
      CALL GRMOVA(XPTS(1),YPTS(1))
      CALL PGEBUF
C
      END

      subroutine write_model_file_text(NL,VT,VB,DZ,VST,VSB,RHOT,RHOB,outbound)
!      implicit none

      DIMENSION VT(*),VB(*),DZ(*),VST(*),VSB(*),RHOT(*),RHOB(*)
      character (len=300) :: outbound
      integer NL


!      integer :: result
!     print *, 'write_model_file_text, outbound is: ', outbound

!
! WRITES VELOCITY MODEL In a file
!
       ICH = 9
       open (unit=ICH,file=outbound,status='replace')

       WRITE(ICH,50)
       WRITE(ICH,100)
       WRITE(ICH,50)
!
       A1=0.
       A2=0.
       DO 20 I=1,NL
       A1=A1+DZ(I)
!COMPUTES 2-WAY TRAVELTIME ASSUMING EITHER CONSTANT VELOCITY OR
!CONSTANT VELOCITY GRADIENT LAYERS.
!
       IF(VT(I).EQ.VB(I)) THEN
              A2=A2+2.*DZ(I)/VT(I)
       ELSE
              A2=A2+2.*DZ(I)*ALOG(VB(I)/VT(I))/(VB(I)-VT(I))
       ENDIF
!
       WRITE(ICH,200) I,VT(I),VB(I),DZ(I),A1,A2,VST(I),VSB(I),RHOT(I),RHOB(I)
20     CONTINUE
       WRITE(ICH,50)
!
50     FORMAT('')
100    FORMAT(3X,'#',4X,'VTOP',3X,'VBOTT',6X,'DZ',3X,'ZBOTT',4X,'TWTT',3X,'VSTOP',2X,'VSBOTT',4X,'RHOT',4X,'RHOB')
200    FORMAT(I4,11F8.5)
!
!       RETURN

      close (ICH)

!      print *, 'result',result

      end subroutine write_model_file_text

	SUBROUTINE TXGRD(P,VT,VB,DZ,T,X,IN)
C THIS SUBROUTINE COMPUTES 2-WAY TRAVELTIME (T) AND HORIZONTAL DISTANCE (X)
C FOR A RAY OF RAY PARAMETER P TRAVELLING IN A CONSTANT VELOCITY GRADIENT
C LAYER OF THICKNESS DZ AND TOP AND BOTTOM VELOCITIES VT AND VB
C RESPECTIVELY.THE SORT OF COMPUTATION DONE IN THE SUBROUTINE IS TRANFERRED
C TO THE MAIN PROGRAM BY THE INTEGER  IN . WE HAVE THE FOLLOWING CODE:
C
C IN=0  IF 1/P L.E. VT  NO CONTUTATION IS CARRIED OUT IN THIS CASE
C
C IN=1 IF VB.L.E. 1/P.GT.VT. RAY IS TURNED WITHIN THE LAYER
C
C IN=2 IF 1/P.G.T.VB  RAY NOT TURNED WITHIN THE LAYER
C
C IN=3  IF  VT=VB (HOMOGENEOUS LAYER)
C
C TEST FOR P=0 *****
	IF(P.EQ.0.) GO TO 10
C
	PM1=1./P
C *** TEST FOR 1/P ****
	IF(PM1.GT.VT) GO TO 10
	IN=0
	RETURN
C
C *** TEST FOR HOMOGENEUOS LAYER  ****
C
 10	IF(VT.NE.VB) GO TO 30
C ***COMPUTE X AND T FOR HOMOGENEOUS LAYER  ****
	A1=P*VT
	A2=2.*DZ/SQRT(1.-A1**2)
	T=A2/VT
	X=A2*A1
	IN=3
	RETURN
C
C **COMPUTE 2./GRADIENT :::
 30	GM1T2=2.*DZ/(VB-VT)
C
	A1=1./VB
	IF(P.GE.A1) GO TO 50
C ***COMPUTATION FOR RAY THAT PASSES THROUGH THE LAYER ***
C
	A1=VB/VT
	A2=SQRT(1.-(P*VT)**2)
	A3=SQRT(1.-(P*VB)**2)
	T=GM1T2*ALOG(A1*(1.+A2)/(1.+A3))
	X=0.
	IF(P.EQ.0.) GO TO 45
	X=GM1T2*(A2-A3)/P
 45	IN=2
	RETURN
C *** COMPUTATION FOR TURNING RAY ***
C
 50	A1=P*VT
	A2=SQRT(1.-A1**2)
	T=GM1T2*ALOG((1.+A2)/A1)
	X=GM1T2*A2/P
	IN=1
	RETURN
	END

      subroutine Project_config (set_DIR,get_DIR)

!      use variables
      implicit none
!       read a configuration file
      integer :: result
      character (len=80) :: inbound, equal, answer
      character (len=30) :: format0,format1,format2,format3
      character (len=30) :: format4,format5,format6
      character (len=30) :: format7,format8,format9
      character (len=30) :: format10,format11,format12,format13
      character (len=30) :: format14,format15,format16
      character (len=255) :: set_DIR, get_DIR, path,Project_conf_file
      character (len=255) :: temp
      character (len=255) :: HOME, PROJECT_HOME, site, spare_dir
      character (len=255) :: date, component, line, subUser
      character (len=255) :: geomaps, geopsy,gmt, grass
      character (len=255) :: matlab, mmodpg, sqlite
      character (len=255) :: HOME_n, PROJECT_HOME_n,site_n,spare_dir_n
      character (len=255) :: date_n, component_n,line_n,subUser_n
      character (len=255) :: geomaps_n,geopsy_n,gmt_n,grass_n
      character (len=255) :: matlab_n, mmodpg_n, sqlite_n

!      define formats
      format1= "(A4,31X,A1,1X,A)"
      format2= "(A12,23X,A1,1X,A)"
      format3 = format1
      format4 = "(A9,26X,A1,1X,A)"
      format5 = format1
      format6 = format4
      format7 = format1
      format8 = "(A8,27X,A1,1X,A)"
      format9 = format8
      format10 = "(A6,29X,A1,1X,A)"
      format11 = "(A3,32X,A1,1X,A)"
      format12 = "(A5,30X,A1,1X,A)"
      format13 = format10
      format14 = format10
      format15 = format10

!      get user's home directory
      CALL get_environment_variable("HOME",HOME)
      path = "/.L_SU/configuration/active/Project.config"
      inbound = trim(HOME)//path
!      print *, 'Project_config.f,  Project_config_file:',inbound

!      read active Project configuration file
      open(unit=1,file=inbound,status='old')
!      print * , 'Project_config.f,  Project_config_file:',inbound
       read (1,format1) HOME_n,equal,HOME
       read (1,format2) PROJECT_HOME_n,equal,PROJECT_HOME
       read (1,format3) site_n,equal,site
       read (1,format4) spare_dir_n,equal,spare_dir
       read (1,format5) date_n,equal,date
       read (1,format6) component_n,equal,component
       read (1,format7) line_n,equal,line
       read (1,format8) subUser_n,equal,subUser
       read (1,format9) geomaps_n,equal,geomaps
       read (1,format10) geopsy_n,equal,geopsy
       read (1,format11) gmt_n,equal,gmt
       read (1,format12) grass_n,equal,grass
       read (1,format13) matlab_n,equal,matlab
       read (1,format14) mmodpg_n,equal,mmodpg
       read (1,format15) sqlite_n,equal,sqlite

      close(unit=1)

!      print *, 'Project_config.f,HOME_n=',trim(home_n)
!      print *, 'Project_config.f,HOME,HOME=',trim(HOME)
!      print *, 'Project_config.f,PROJECT_HOME_n=',trim(PROJECT_HOME_n)
!      print *, 'Project_config.f,PROJECT_HOME=',trim(PROJECT_HOME)
!      print *, 'Project_config.f,site_n=',trim(site_n)
!      print *, 'Project_config.f,site=',trim(site)
!      print *, 'Project_config.f,spare_dir=',trim(spare_dir)
!      print *, 'Project_config.f,spare_dir_n=',trim(spare_dir_n)
!      print *, 'Project_config.f,date_n=',trim(date_n)
!      print *, 'Project_config.f,date=',trim(date)
!      print *, 'Project_config.f,component_n=',trim(component_n)
!      print *, 'Project_config.f,component=',trim(component)
!      print *, 'Project_config.f,line_n=',trim(line_n)
!      print *, 'Project_config.f,line=',trim(line)
!      print *, 'Project_config.f,subUser_n=',trim(subUser_n)
!      print *, 'Project_config.f,subUser=',trim(subUser)
!      print *, 'Project_config.f,geomaps_n=',trim(geomaps_n)
!      print *, 'Project_config.f,geomaps=',trim(geomaps)
!      print *, 'Project_config.f,gmt_n=',trim(gmt_n)
!      print *, 'Project_config.f,gmt=',trim(gmt)
!      print *, 'Project_config.f,grass_n=',trim(grass_n)
!      print *, 'Project_config.f,grass=',trim(grass)
!      print *, 'Project_config.f,matlab_n=',trim(matlab_n)
!      print *, 'Project_config.f,matlab=',trim(matlab)
!      print *, 'Project_config.f,mmodpg_n=',trim(mmodpg_n)
!      print *, 'Project_config.f,mmodpg=',trim(mmodpg)
!      print *, 'Project_config.f,sqlite_n=',trim(sqlite_n)
!      print *, 'Project_config.f,sqlite=',trim(sqlite)
!       print *, '1 Project_config.f, get_DIR:',trim(set_DIR)

      if (trim(set_DIR) == 'IMMODPG') then

       temp = trim(PROJECT_HOME)//"/seismics/mmodpg/"//trim(site)
       temp = trim(temp)//"/"//trim(spare_dir)//"/"//trim(date)
       temp = trim(temp)//"/"//trim(component)//"/"//trim(line)
       temp = trim(temp)//"/"//trim(subUser)
       get_DIR = temp
!       print *, '2 Project_config.f, get_DIR:',trim(get_DIR)

      end if

      if (trim(set_DIR) == 'IMMODPG_INVISIBLE') then

       temp = trim(PROJECT_HOME)//"/seismics/mmodpg/"//trim(site)
       temp = trim(temp)//"/"//trim(spare_dir)//"/"//trim(date)
       temp = trim(temp)//"/"//trim(component)//"/"//trim(line)
       temp = trim(temp)//"/"//trim(subUser)//"/.immodpg"
       get_DIR = temp
!       print *, '3 Project_config.f, get_DIR:',get_DIR

      end if

      if (trim(set_DIR) == 'DATA_SEISMIC_BIN') then

       temp = trim(PROJECT_HOME)//"/seismics/data/"//trim(site)
       temp = trim(temp)//"/"//trim(spare_dir)//"/"//trim(date)
       temp = trim(temp)//"/"//trim(component)//"/"//trim(line)
       temp = trim(temp)//"/"//"bin"
       temp = trim(temp)//"/"//trim(subUser)
       get_DIR = temp
!       print *, '3 Project_config.f, get_DIR:',trim(get_DIR)

      end if
!       Deallocate (str)
!       in case definition in main is slightly different
!       pre_digitized_XT_pairs = 'no'
!       data_traces = 'no'
!       previous_model = 'no'
!       new_model = 'no'

!      print *, 'Project_config.f, inbound is:', inbound
!      in case inbound is of a different length in main
!       inbound=inbound
!      open(unit=1,file=inbound,status='old')

!       read (1,format1) name,equal,pre_digitized_XT_pairs
!       read (1,format2) name,equal,data_traces
!       read (1,format3) name,equal,clip
!       read (1,format4) name,equal,min_t_n
!       read (1,format5) name,equal,min_x_m

!       Project_directories(2)%str = 'sssssssssss'
!       Project_directories(3)%str = 'q'
!       write(*,'(a)') (Project_directories(i)%str,i=1,3)

!       result = 1

!      if (answer == 'yes')

!      print(*), 'bingo=',result
!      end if


      end subroutine Project_config

!      module variables
!         type string
!           character(len=:), allocatable :: str
!         end type string
!       end module variables

! Calculo de curvas camino-tiempo para modelos formados por una
! combinacion de capas planas homogeneas o con gradiente de
! velocidad constante. Fuente y receptor en 1ra capa; default
! es que ambos esten en superficie.
!      for sleeping
       use :: posix
       integer*4  count_sleep, record_sleep, sleep_time_ms
       integer*4  sleep_time_usec,ms2us
       integer*4  nlmax,npmax,npamax,ntrmax,nsmax,ntr,ns,idtusec
       integer*4  nchanges
       integer*2  how_many
       parameter (nlmax=25,npmax=960000,npamax=4000000)
       parameter (ntrmax=5000,nsmax=65536)
       parameter (nxymax=2000)
       parameter (nchanges=100000)
       real*4    Amp(ntrmax,nsmax)
       real*4    Amp_min,Amp_max,tr(6)
       dimension IR(nlmax-1),VT(nlmax),VB(nlmax),DZ(nlmax)
       dimension VST(nlmax),VSB(nlmax),RHOT(nlmax),RHOB(nlmax)
       dimension va(2*nlmax),za(2*nlmax)
       dimension va_prior(2*nlmax), za_prior(2*nlmax)
       dimension multin(nlmax)
       dimension ILA(npmax),P(npmax),X(npmax),T(npmax)
       dimension xa1(npamax),xa2(npamax),xa3(npamax),xa4(npamax)
       real      a1,a2,a1_prior,a2_prior,time_delay,VPlotScale
       real      VPlotMax,ZPlotMax,VPlotMax_prior,ZPlotMax_prior
!      next line added on Aug 20 2013
       dimension xout(npmax,nlmax)
       dimension tout(npmax,nlmax),array_ntp(npmax)

       dimension xdig(nxymax),tdig(nxymax)
       character*300 set_DIR, get_DIR
       character*300 inboundVincrement, inboundVbotNtop_factor
       character*300 inbound_change, inbound_config, inbound_option
       character*300 inbound_layer, inbound_par, inbound_clip
       character*300 inbound_thickness_m
       character*300 inboundVbot,inboundVtop
       character*300 inboundVbot_upper,inboundVtop_lower
       character*300 outbound_option, outbound_model_txt
       character*300 outbound_wrkng_modl_txt
       character*300 outbound_model_bin, outbound_model_bin_bck
       character val,finxy*40
       character*40 change_file,config_file,no,option_file,layer_file
       character*40 clip_file, model_file_text, thickness_m_file
       character*40 working_model_txt
       character*40 model_file_bin, model_file_bin_bck
       character*40 Vbot_file,Vbot_upper_file,Vtop_file,Vtop_lower_file
       character*40 Vincrement_file, VbotNtop_factor_file
       character*40 par_file, moveNzoom_file
       character*40 base_file
       logical   flag, is_change, ans
       integer   upper_layer_number,lower_layer_number
       integer   option,layer,option_default
       integer   VtopNVot_upper_layer_optresult
       integer   VbotNVtop_lower_layer_opt
       integer   Vtop_plus_opt, Vtop_minus_opt
       integer   Vbot_plus_opt, Vbot_minus_opt
       integer   VbotNVtop_plus_opt, VbotNVtop_minus_opt
       integer   VtopNVbot_upper_layer_plus_opt
       integer   VtopNVbot_upper_layer_minus_opt
       integer   VbotNVtop_lower_layer_plus_opt
       integer   VbotNVtop_lower_layer_minus_opt
       integer   change_VbotNtop_factor_opt,zoom_plus_opt
       integer   zoom_minus_opt
       integer   VbotNtop_multiply_opt
       integer   changeVtop_lower_layer_opt,  changeVbot_upper_layer_opt
       integer   changeVbot_opt, changeVtop_opt
       integer   move_image_down_opt, move_image_left_opt
       integer   move_image_up_opt,move_image_right_opt
       integer   change_velocity_opt
       integer   change_thickness_increment_opt
       integer   changeVincrement_opt, exit_opt, change_clip4plot_opt
       integer   change_layer_number_opt,new_layer_number
       integer   change_thickness_m_opt
       integer   thickness_m_minus_opt, thickness_m_plus_opt
       integer   current_layer_number,prior_layer_number
       integer   current_moveNzoom
       integer   prior_moveNzoom
       integer   new_moveNzoom
       integer   i_change, i_past_change
       real*4    datadt
       real*4    new_thickness_m, current_thickness_m,prior_thickness_m
       real*4    current_thickness_km
       real*4    Vtop_mps,Vbot_mps,Vtop_lower_mps,Vbot_upper_mps
       real*4    Vtop_kmps,Vbot_kmps,Vtop_lower_kmps,Vbot_upper_kmps
       real*4    thickness_increment_m, Vincrement_mps
       real*4    thickness_increment_km
       real*4    VbotNtop_factor, Vincrement_kmps, m2km, km2m, us2ms
       real*4    result(30)
       real      current_clip,prior_clip,new_clip, clip_max, clip_min
       real      priorVincrement_mps, currentVincrement_mps
       real*4    newVincrement_mps
       real      prior_thickness_increment_m
       real      current_thickness_increment_m, new_thickness_increment_m
       real      priorVbotNtop_factor, currentVbotNtop_factor
       real      newVbotNtop_factor
       real      priorVtop, currentVtop, newVtop
       real      priorVbot, currentVbot, newVbot
       real      priorVtop_lower, currentVtop_lower, newVtop_lower
       real      priorVbot_upper, currentVbot_upper, newVbot_upper
       real      start, finish, cpu_duration, start_change
       real,dimension(nchanges)::last_change,change_step
       real      governor

       
!       Modified: Juan Lorenzo LSU
!       Date: June 17 2004
!       Purpose: explanation of parameters
!       Increased memory range
!
!       DICTIONARY AND DEFINITIONS
!       array_npt       number of total calcualted points in each layer
!       change_file     a messaging file contining either yes or no

        Vbot_file            = "Vbot"
        Vbot_file            = trim(Vbot_file)
        Vbot_upper_file      = "Vbot_upper_layer"
        Vbot_upper_file      = trim(Vbot_upper_file)
        Vincrement_file      = "Vincrement"
        Vincrement_file      = trim(Vincrement_file)
        Vtop_file            = "Vtop"
        Vtop_file            = trim(Vtop_file)
        Vtop_lower_file      = "Vtop_lower_layer"
        Vtop_lower_file      = trim(Vtop_lower_file)
        VbotNtop_factor_file = "VbotNtop_factor"
        VbotNtop_factor_file = trim(VbotNtop_factor_file)
        change_file          = "change"
        change_file          = trim(change_file)
        clip_file            = "clip"
        clip_file            = trim(clip_file)
        config_file          = "immodpg.config"
        config_file          = trim(config_file)
        model_file_text      = "model.txt"
        model_file_text      = trim(model_file_text)
        working_model_txt    = "working_model.txt"
        working_model_txt    = trim(working_model_txt)
        model_file_bin       = "immodpg.out"
        model_file_bin       = trim(model_file_bin)
        model_file_bin_bck   = ".immodpg.out"
        model_file_bin_bck   = trim(model_file_bin_bck)
        
        VPlotScale         = 1.25
        ichange             = 0
        inbound_config      = ''
        get_DIR             = ''
        set_DIR             = ''
        inbound_config      = ''
        governor            = 0.1
        ichange             = 1
        is_change           = .FALSE.
        last_change(1)      = 0
        layer_file          = "layer"
        layer_file          = trim(layer_file)
        no                  = "no"
        option_file         = "option"
        par_file            = "parmmod"
        par_file            = trim(par_file)
        new_layer_number    = -1
        current_layer_number =-1
        prior_layer_number  =-2
        thickness_m_file    = "thickness_m"
        time_delay          = 0.01 ! wait seconds for Perl processing
        sleep_time_ms       = 250 ! default in milliseconds

!      Coded user options
       changeVbot_opt                     = 20
       Vbot_minus_opt                     = 21
       Vbot_plus_opt                      = 22
       changeVbot_upper_layer_opt         = 23

       VbotNVtop_lower_layer_minus_opt    = 61
       VbotNVtop_lower_layer_plus_opt     = 62
       VbotNVtop_minus_opt                = 41
       VbotNVtop_plus_opt                 = 42
       changeVtop_opt                     = 10
       changeVtop_lower_layer_opt         = 11
       Vtop_minus_opt                     = 12
       Vtop_plus_opt                      = 13
       VbotNtop_multiply_opt              = 16
       VtopNVbot_upper_layer_minus_opt    = 51
       VtopNVbot_upper_layer_plus_opt     = 52
       change_layer_number_opt            = 0
       change_thickness_m_opt             = 142
       change_thickness_increment_opt     = 15
       changeVincrement_opt               = 7
       changeVbotNtop_factor_opt          = 68
       change_clip4plot_opt               = 9
       thickness_m_minus_opt              = 140
       thickness_m_plus_opt               = 141
       write_simple_model_text_opt        =70
       write_model_bin_opt                = 71
       exit_opt                           = 99
       option_default                     = -1
       option                             = option_default
!      default velocity model km per sec
!      a2 is X coord-top_right (Vel-km/s); Vmax
!      a1 is Y coord (depth-km), Zmax
!      bottom left model - ymax can be negative
!       a1 =  0.0
!       a2 = -1.0
!       a1_prior =  0.0
!      a2_prior = -1.0
!       datax1          nearest offset (km)
!       datadx          trace offset increment (km)
!       datadt          sample interval (s)
!       datat1          time value of first sample (s)
!       governor        multiplicative value to slow down
!                       GUI looping
!       inbound_bin    full path to stripped su file
!       inbound_par     path to the parameter file
!       dp              increment of p for each ray
!       nlmax           maximum number of layers allowed
!       nchanges        number of gui interactions allowed
!       npmax           maximum number of  allowded
!       npamax          maximum number of  allowded
!       ns              number of samples per trace
!       ntp             total number of computed points
!       ntr             number of traces in file
!       ntrmax          maximum number of traces allowed
!       nsmax           maximum number of samples allowed
!       par_file        contains no. traces, no. samples, SI (usec)
!       start_change    time at which GUI induces a change
!       last_change     array of times at which GUI is clicked
!       change_step     array of time delays between GUI clicks

!       Amp_min            minimum amplitude
!       Amp_max            maximum amplitude
!       multin
!       rv 		reducing velocity km/s
!
!       how often user calls immodpg via a click in the  gui
       thickness increment_m = 10.
       Vincrement_mps       = 10.
!       tout             time output, 
!       Aug 2013 by Juan
!       va and va_prior, za and za_prior are velocity  and depth
!       vectors for plotting the velocity-versus-depth model om
!       far right side
!       xa1
!       xa2
!       xa3
!       xa4
!       xout
!      output distance of distance,time calculated pairs
!       va
!       za
!      xmax            maximum plotting distance
!               Should be greater than maximum offset in
!               order to allow V-Z plot to show on black
!               background ; in km
!       tmax            maximum time of data
!       tmin            minimum time of data
!       xinc    increment for km/s in modeling or thickness in modelign

! DEFAULT PARAMETERS
! OLD for big-scale marine work
! 	pmin   = 0.0
! 	pmax   = 3.0
! 	pmax   = .6
       km2m  = 1000.
       m2km  = .001
       us2ms = .001
       ms2us = 1000
       sdepth = 0.0
       rdepth = 0.0

! pmax = 40 s/km   V= 25 m/s
! pmin = 5   s/km  V= 200 m/s
!
	pmin   = 0
        pmax   = 40
! 	dp     = 0.0005
! 	dp     = 0.001
	dp     = 0.0001
        vmf    = 1./sqrt(3.)
! 	rv     = 1.0
	rv     = .0
!       km
	xmin   = 0.0
	xmax   = 0.120
! 	xmax   = 20.
! 	delt   = -10 ms
! 	tmin   = -0.010
	 tmin   = 0.0
! 	tmax   = 6
	 tmax   = 1.
       current_layer_number    = 1
	icolor = 0
	xinc   = 0.1
	iout   = 35
	datadx = 0.001
! 	datadx = 0.2
        datax1 = 0.001
!        datax1 = 0
! 	datadt = 0.005
        datat1 = 0.0
        flag   = .false.
	 idred  = 0
        idrdtr = 0
        idrxy  = 0
!
	  do i=1,nlmax
		multin(i) = 1
	  enddo

! define the different needed directories
        set_DIR = "IMMODPG"
       call Project_config(set_DIR,get_DIR)
       
! define needed files
! trim blank spaces to left and right
       inbound_config = trim(get_DIR)//"/"//config_file
       outbound_model_txt = trim(get_DIR)//"/"//model_file_text
       outbound_wrkng_modl_txt=trim(get_DIR)//"/"//working_model_txt
       outbound_model_bin = trim(get_DIR)//"/"//model_file_bin
       outbound_model_bin_bck = trim(get_DIR)//"/"//model_file_bin_bck
       
! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
!      print*, '1. immodpg.for, get_DIR:',trim(get_DIR),'--'
!      print*, '1. immodpg.for, change_file:',change_file,'--'
!      inbound_change = trim(get_DIR)//"/"//change_file
       inbound_layer  = trim(get_DIR)//"/"//layer_file
       inbound_option = trim(get_DIR)//"/"//option_file
       outbound_option=inbound_option

! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
       inboundVtop_lower = trim(get_DIR)//"/"//Vtop_lower_file

! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
       inboundVbot = trim(get_DIR)//"/"//Vbot_file

! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
       inboundVtop = trim(get_DIR)//"/"//Vtop_file

! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
       inboundVbot_upper = trim(get_DIR)//"/"//Vbot_upper_file

! define the different needed directories
       set_DIR = "IMMODPG_INVISIBLE"
       call Project_config(set_DIR,get_DIR)
!      print*, '1. immodpg.for, get_DIR:',trim(get_DIR),'--'
!      print*, '1. immodpg.for, change_file:',change_file,'--'
       inboundVincrement  = trim(get_DIR)//"/"//Vincrement_file
!      print*,'inboundVIncrement=',inboundVincrement
       inboundVbotNtop_factor  =
     +trim(get_DIR)//"/"//VbotNtop_factor_file
        inbound_thickness_m =trim(get_DIR)//"/"//thickness_m_file
        
! read all the configuration parameters for immodpg
! i/p inbound_config
! o/p base_file, result,
       call read_immodpg_config(base_file,result,inbound_config)
!      print*, 'L 346, base_file=',base_file

! Read digitized X-T pairs, 0- No',idrxy
       idrxy=int(result(1))
       
!  Read data traces, 0- No',idrdtr
      idrdtr=int(result(2))
      datat1    =result(4)
      datax1    =result(5)
      datadx    =result(6)
      
!SOURCE AND RECEIVER DEPTH DEFINITION (KM)
      SDEPTH  = result(7)
      RDEPTH  = result(8)
      
! DEFINE PLOTTING AREA ENTER
! linear reduction velocity in mps
      rv = result(9)
      xmin = result(10)
      xmax = result(11)
      tmin = result(12)
      tmax = result(13)
      
! result16 is the starting layer from the settings file
      starting_layer       = result(16)
      current_layer_number = int(starting_layer)
      VbotNtop_factor      = result(17)
      Vincrement_kmps       = result(18)
      thickness_increment_km =result(19)

!      print*, 'immodpg.for,read pre_digitized_XT_pairs (y/n)=',idrxy
!       print*, 'immodpg.for,reading data_traces(y/n)=',idrdtr
!      print*, 'immodpg.for,datat1 (S)=',datat1
!      print*, 'immodpg.for,datax1 (KM)=',datax1
!      print*, 'immodpg.for,datadx (X)=',datadx
!      print*, 'immodpg.for,SDEPTH (KM)=',SDEPTH
!      print*, 'immodpg.for,RDEPTH (KM)=',RDEPTH
!
!      print*, 'immodpg.for,PLOTTING LAYOUT'new_clip
!      print*, 'immodpg.for,MINIMUN DISTANCE (KM)xmin=',xmin
!      print*, 'L300 immodpg.for,MAXIMUN DISTANCE (KM)=',xmax
!      print*, 'immodpg.for,tmin (s)=',tmin
!      print*, 'immodpg.for,tmax (s)=',tmax
!      print *, "immodpg.for,starting layer:", current_layer_number
!      print*, 'immodpg.for,VbotNtop_factor=',VbotNtop_factor
!      print*, 'immodpg.for,Vincrement_kmps=',Vincrement_kmps

! Read digitized X-T pairs, 0- No',idrxy
      if(idrxy.eq.1) then
         finxy = '???'
         call read_dataxy(xdig,tdig,ndxy,finxy,21,1)
      endif

! READ BINARY SU FILES STRIPPED of ALL HEADERS
      if(idrdtr.eq.1) then
!         print*, 'immodpg.for,reading data_traces=',idrdtr

! datadt is returned
! Read data parameters
! retufns ntr, ns and idtusec
! define the different needed directories
       set_DIR = "IMMODPG"
       call Project_config(set_DIR,get_DIR)
       inbound_par    = trim(get_DIR)//"/"//par_file
!       print*,'immodpg.for,inbound_par:',trim(inbound_par),'--'
       call read_parmmod_file(inbound_par,ntr,ns,idtusec)
!        write(*,*) 'immodpg.for,inbound_par:idtusec',idtusec     
       datadt = float(idtusec) * 1e-6
!      write(*,*) 'immodpg.for,inbound_par:datadt',datadt

!      error checking
!       if (ntr.GT.ntrmax) print*,'error:traces>20000'
!       if (ns.GT.nsmax) print*,'error: samples>= 65536'

       call rdata(Amp,ntrmax,nsmax,ntr,ns,Amp_min,Amp_max)
             
       print*,'immodpg.for,rdata:ns,ntr',ns,'--',ntr
       
! Clips for gray scale (pggray)
         current_clip   = Amp_max/100

! User override of clips for gray scale (pggray)
         current_clip   = result(3)
         clip_min    = -current_clip
         clip_max    =  current_clip
!         print*, '330 immodpg.for,clip_min=',clip_min
!         print*, '331 immodpg.for,current_clip=',current_clip

       endif ! end read bin data file

!15    continue

! **** PARAMETERS FOR THE X-T PLOT  ****
!      DEFINE  PLOTTING AREA
! reduction velocity
	rvinv=0.

	if (rv.eq.0.) go to 40
	  rvinv=1./rv/m2km  ! used to be 1./rv
	  idred=1 ! 1-yes 0-No JML 3-30-2020
40	continue

!       if(idrdtr.eq.1) then
!	 call read_par_i4('1-Traces are red. by this vel., 0-No',idred)
!       endif

! Transformation Matrix between data array and world coordinates
        rvinvd = 0.0
! if no velocity reduction (idred=0)
        if(idred.eq.0) rvinvd = rvinv
        print*, '473 immodpg.for,rvinvd=',rvinvd
        
! *******************
	tr(1)  =  datax1 - datadx
	tr(2)  =  datadx
	tr(3)  =  0.0
	tr(4)  =  datat1 - datadt - tr(1)*rvinvd
	tr(5)  = -datadx*rvinvd
	tr(6)  =  datadt

! READ VELOCITY DEPTH MODEL
!       call execute_command_line ("fg",exitstat=i, cmdmsg=message)
!       print *, "Exit status of fg was ", i
!       print *, "Message from fg was ", message
!       show model to user for the first time
	call READMMOD(VT,VB,DZ,VST,VSB,RHOT,RHOB,nl)
!       print*, 'L 470  immodpg.for,readmod'

! error check the working layer number
	if(current_layer_number.lt.1)   current_layer_number = 1
	if(current_layer_number.gt.nl)  current_layer_number = nl

! Open X-T Window ****************
!       print *,' 1. start '
!       call pgbegin(0,'?',1,1)  !ask what device to use

	call pgbegin(0,' ',1,1)  ! use default device

!      width_in,aspect 11 " wide and 8/11 high
	call pgpaper(10.75,0.75)
! (XLEFT, XRIGHT, YBOT, YTOP)
!	call pgvport(-5.,1.,0.,1.)
!       call pgsvp(0.0,0.5,0.5,1.0)
       call pgask(flag)
       
       a2_prior = -1.0
       a1_prior =  0.
       do 8  i = 1,current_layer_number
              k = 2*i - 1
              va_prior(k) = vt(i)
              if(vt(i).gt.a2_prior) a2=vt(i)
              za_prior(k) = a1_prior
              va_prior(k+1) = vb(i)
              if(vb(i).gt.a2) a2=vb(i)
              a1_prior = a1_prior + dz(i)
              za_prior(k+1) = a1_prior
8     continue
! End of setup
! user sees an EMPTY BLACkKSCREEN
!       print *,' 1. start of principal input loop'
10	continue

************************************
! START OF ALL INTERACTIONS WITH THE USER
!       print *,' L511 start of interaction with the user'

! Check for Vtop-Vbottom too small.-km/s
!	A3 = 0.001
	A3 = 0.00001
!       print*, '1D. immodpg.for,made it, current_layer_number=',
!     +  current_layer_number

       do i = 1, current_layer_number

	if(ABS(VT(i)-VB(i)).le.A3) vb(i) = vt(i)

       end do

!      Reflections at the bottom of layers decided automatically
!      based on velocity discontinuities
	do i=1,nl-1
         IR(i)=0 
    	 if(ABS(VT(i+1)-VB(i)).GT.A3) IR(i)=1     
        end do 
        
 !** No reflection at the bottom of model
	IR(nl) = 0  
	
	print*,'reflection at layer i,=',i,IR(i)

!      COMPUTATIONS ***
	DZ1TEM=DZ(1)

!      Correct only if 1st layer is a constant vel. layer.
	DZ(1)=DZ(1)-(SDEPTH+RDEPTH)/2.

	call txpr(nl,VT,VB,DZ,PMIN,PMAX,DP,IR,multin,ntp,ILA,P,X,T)
	DZ(1)=DZ1TEM

55	continue

!      PLOTTING and REPLOTTING when correct option turns
       call pgpage ! clear screen
!       left_bottom_X, right_top_X,left_bottom_Y,right_top_Y
!      0.7= Xfraction of black screen occupied by seismic data
       call pgvport(0.15,0.75,0.15,0.9)
!      real character size in proportion to 1
       call pgsch(1.25)
       call pgwindow(xmin,xmax,tmax,tmin)
       call pgbox('BCTN',0.0,0,'BCTN',0.0,0)
       call pglabel('X(km)','Tred (sec)',
     + 'Primary P-wave T-X Curves, 1-D Model')
!
!      plot seismic image in a window
       if(idrdtr.eq.1) then
!        print *, 'L561, clip_min,clip_max=',clip_min,clip_max
!        print *, 'L562, ns,ntr=',ns,ntr
!        print *, 'L563, ntrmax,nsmax=',ntrmax,nsmax  
!        clip_min = -1.00000
!        clip_max = 1.00000
	 call pggray(Amp,ntrmax,nsmax,1,ntr,1,ns,clip_max,clip_min,tr)
!         print *, 'L543, plot seismic image in window' 

       endif
!
!      plot modelled arrivals by layer
       do 140 j=1,current_layer_number
         nplj = 0
         array_ntp(j) = ntp

!        plot first breaks in a layer
	  do 120 i=1,ntp

! ** SELECT LAYER J **
!            nplj - number of points in layer j
	    if(ABS(ILA(i)).NE.J) go to 120
	       nplj = nplj+1
	       xa1(nplj)  =   X(i)
	       xa2(nplj)  =   T(i) - X(i) * rvinv !** RED. TIME
	       xa3(nplj)  =   P(i)
              xa4(nplj)  =   T(i) - X(i) *  P(i) !** TAU
!             get ready to output all the data
              xout(nplj,j) = X(i)
              tout(nplj,j) = T(i)

!        write(*,*)'*** test output *****************************'
!        write(*,*)'nplj=',nplj,' layer is ',j
!        write(*,*) xout(nplj,j),tout(nplj,j)
!	  write(*,*) 'L 374 total # of computed points ',ntp

120	continue ! points in each layer

	if(nplj.eq.0) go to 140 ! new layer
!
!      PLOT LAYER J **
	icolor = icolor + 1

!      pick a different color for arrivals that travel
!      through a new deeper layer
       if(icolor.gt.15) icolor = 1

	call pgsci(icolor)
!      print*, 'immodpg.for,read pre_digitized_XT_pairs (y/n)=',idrxy
!      print*, 'immodpg.for,reading data_traces(y/n)=',idrdtr
!      print*, 'immodpg.for,datat1 (S)=',datat1
!      print*, 'immodpg.for,datax1 (KM)=',datax1
!      print*, 'immodpg.for,datadx (X)=',datadx
!      print*, 'immodpg.for,SDEPTH (KM)=',SDEPTH
!       print*, 'L614 immodpg.for,RDEPTH (KM)=',RDEPTH
!
!      print*, 'immodpg.for,PLOTTING LAYOUT'
!      print*, 'immodpg.for,rv (KM/S)=',rv
!      print*, 'immodpg.for,MINIMUN DISTANCE (KM)xmin=',xmin
!      print*, 'L619 immodpg.for,MAXIMUN DISTANCE (KM)=',xmax
!      print*, 'immodpg.for,tmin (s)=',tmin
!      print*, 'immodpg.for,tmax (s)=',tmax
!      print *, "immodpg.for,starting layer:", current_layer_number

!	call pgsci(3)
!
! X - T Plot of first arrival points for a fixed layer
!
       call pgline(nplj,xa1, xa2)
!       print *, 'L629,plot first arrival points for a fixed layer'

! TAU - P Plot **
!
!       call gks$polyline(nplj, xa3, xa4)
!
140   continue ! go to a new layer
!
! Draw digitized X-T data if it exists
!
      if(idrxy.eq.1) then

         do ixy = 1,ndxy
             xa2(ixy) = tdig(ixy) - xdig(ixy) * rvinv
         enddo

	 call pgsci(3)
         call pgpoint(ndxy,xdig,xa2,9)  ! TODO perhaps
         print *, 'L647 Draw digitized X-T data if it exists'

      endif
!
!      Draw velocity vs. depth plot at far right
!      STEP 1: Erase previous model
!       0 = black (erase)
       VPlotMax_prior=a2_prior*VPlotScale
       ZPlotMax_prior=a1_prior*1.0
       call pgsci(0)
       call pgvport(0.88,0.98,0.2,0.8)
       call pgwindow(0.0,VPlotMax_prior,ZPlotMax_prior,0.0)
       call pgbox('BCTN',0.0,0,'BCNST',0.0,0)
       call pglabel('V(km/s)','Z(km)','')
       call pgline(2*current_layer_number,va_prior,za_prior)
!       print *, 'L 555 current layer number is ', current_layer_number
!       print *, 'L 556 end of draw velocity model'

!      STEP 2: Calculate the current model
! ****** descomentar para trabajo con OBS  ***
!       dz(1) = 2.0 * dz(1)
! ***********************
      a1=0.
      a2=-1.0
      do 145 i = 1,current_layer_number
              k = 2*i - 1
              va(k) = vt(i)
              if(vt(i).gt.a2) a2=vt(i)
              za(k) = a1
              va(k+1) = vb(i)
              if(vb(i).gt.a2) a2=vb(i)
              a1 = a1 + dz(i)
              za(k+1) = a1
145   continue

!      STEP 3: Save the current model as the "prior"
       a1_prior = a1
       a2_prior = a2
       va_prior = va
       za_prior = za

!            STEP 4: Draw the current model
! ****** descomentar para trabajo con OBS  ***
!       dz(1) = dz(1)/2.0
! ***********************
!      set color index: 3 = green
!       white on black background =1
       call pgsci(3)
       VPlotMax=a2*VPlotScale
       ZPlotMax=a1*1.0
 !      print*,'L711,a1,a2',a1,a2
       call pgvport(0.88,0.98,0.2,0.8)
	call pgwindow(0.0,VPlotMax,ZPlotMax,0.0)
	call pgbox('BCTN',0.0,0,'BCNST',0.0,0)
	call pglabel('V(km/s)','Z(km)','')
!	call pgslw(5)
	call pgline(2*current_layer_number,va,za)
!       print *, 'L 594 current layer number is ', current_layer_number
!	call pgslw(1)
!       print *, 'L 596 end of draw velocity model'

150    continue

!     define the different needed directories
      set_DIR = "IMMODPG_INVISIBLE"
      call Project_config(set_DIR,get_DIR)
!      print*, '1. immodpg.for, get_DIR:',trim(get_DIR),'--'
!      print*, '1. immodpg.for, change_file:',change_file,'--'
      inbound_change = trim(get_DIR)//"/"//change_file
      inbound_clip   = trim(get_DIR)//"/"//clip_file
!      print*, '1.immodpg.for,inbound_change:',inbound_change,'--'

       ans = .TRUE.
       icount=0;

       do while (ans)

!       slow fortran for Perl i/o to .001 s
!        call cpu_time(start)
!        print '("Time = ",f6.3," seconds.")',start
! 151    call cpu_time(finish)
!        print*,'slowing'
!        cpu_duration = finish-start
!        print '("Time = ",f6.3," seconds.")',cpu_duration

!        if (cpu_duration .lt. time_delay) then
         sleep_time_usec = sleep_time_ms * ms2us
         record_sleep = c_usleep(sleep_time_usec)
!         print '("sleeping",i20,"milliseconds.")',sleep_time_ms
!         go to 151
!        endif
        
!        print '("Time = ",f6.3," seconds.")',cpu_duration

           icount=icount+1
!          print *, 'L 722 do loop: immodpg,icount=',icount
!          Detect for change:  "yes"
!          print*, '2. immodpg.for,inbound_change:',inbound_change,'--'

           call read_yes_no_file(is_change,inbound_change)
           
!          print*, '737.immodpg.for,is_change:',is_change,'--'
           if (is_change ) then
!	      keep track of change frequency
              i_past_change   = i_change    
              i_change        = i_change+1
              
              call cpu_time(start_change)
!              print '("Time = ",f6.3," seconds.")',start_change             
              change_step(i_change) = start_change
     +             - last_change(i_past_change)
              last_change(i_change) = start_change
!              print*,'change step=',change_step(i_change)
              time_delay = change_step(i_change) * governor

!             Restore change to "no"
              call write_yes_no_file(no,inbound_change)
!             read option number
              call read_option_file(option,inbound_option)
!              print *, 'L755 immodpg.for,is_change=',is_change
!              print *, '756 immodpg.for,option#=',option
!              print *,'L 757 immodpg.for,clnopt=',
!     +        change_layer_number_opt

              if(option.eq.change_layer_number_opt) then
!                CASE change layer option YES
                 call read_layer_file(new_layer_number,inbound_layer)
                 prior_layer_number   = current_layer_number
                 current_layer_number = new_layer_number
!                 print *,'L 517 current layer #:',current_layer_number

!                is layer number new or old?
!                if old, do nothing
                 if (current_layer_number .ne. prior_layer_number)then
!                  CASE 1: new layer detected
                   if(new_layer_number.lt.1) then
                      current_layer_number = 1
!                      print *, 'L516 new current layer_number'
                   endif

                   if(new_layer_number.gt.nl)  then
                      current_layer_number = nl
!                       print *, 'L526. current layer_number'
                   endif

! write modified model to terminal before
!                   changing layer
!
                   write(*,*) ' '
                   write(*,*) 'modified model prior to layer change:'
                   call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
!
! write modified model to file immodpg.out
!
!                   write(*,*) ' '
!                    write(*,*) 'Binary file: immodpg.out'

                   OPEN(UNIT=IOUT,FILE=outbound_model_bin,
     +               STATUS='UNKNOWN',
     +               FORM='UNFORMATTED')
                      do K=1,NL+1
                            write(IOUT) VT(K),VB(K),DZ(K),
     +                      VST(K),VSB(K),RHOT(K),RHOB(K)
                      enddo
                      CLOSE(UNIT=IOUT)

! write modified text file out
!                     write(*,*) ' '
!                     write(*,*) 'Text file: model.txt'
             call write_model_file_text(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB,
     +         outbound_model_txt);
!
!                   print *,'L 703 current layer #:',current_layer_number
                   go to 10 ! start of all interactions with user

                 elseif(current_layer_number.eq.prior_layer_number) then
!                 CASE 2: Stay in the layer
!                 print *, 'L528 NADA layer does not change'

                 else
!                 print *, 'L 531 immodpg.for unexpected case'
                 endif

              endif ! end check for change in layer

!              write out an elicited working text model
              if(option.eq.write_simple_model_text_opt) then

               call write_model_file_text(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB,
     + outbound_wrkng_modl_txt);

              endif

!              write out an elicited  working binary model
              if(option.eq.write_model_bin_opt) then

        OPEN(UNIT=IOUT,FILE=outbound_model_bin,
     + STATUS='UNKNOWN',
     +  FORM='UNFORMATTED')
        do K=1,NL+1
              write(IOUT) VT(K),VB(K),DZ(K),
     +        VST(K),VSB(K),RHOT(K),RHOB(K)
        enddo
        CLOSE(UNIT=IOUT)
              endif

              if(option.eq.change_clip4plot_opt) then
!               print *, 'L 733 immodpg.for,change_clip4plot_opt=',
!     +         change_clip4plot_opt
!              print *, 'L 735 immodpg.for,option=',option
                   call read_clip_file(new_clip,inbound_clip)
!                   print*,'L 737 new clip is',new_clip
                   prior_clip         = current_clip
                   current_clip       = new_clip
                   clip_min           = -current_clip
                   clip_max           =  current_clip
!                   print*,'L 742 new clip is',clip_max
                   go to 10 ! start of all interactions with user

              endif

!             zoom option
!             read_moveNzoom_amount
             if( (option.ge.80)
     +            .and. (option.lt.90) ) then

!                  print *, 'L 564 immodpg.for,zoom,option=',option
                  prior_moveNzoom     = current_moveNzoom
                  current_moveNzoom   = option

                  call moveNzoom(xmin,xmax,tmin,tmax,current_moveNzoom)
                  icolor = 0
                  call pgpage
                  call pgsci(1)
                  go to 55

             endif


!            set thickness increment
             if(option.eq.change_thickness_increment_opt) then
             
!              read new thickness increment value
!              call read_thickness_increment
!              print*,'L 644 new thickness_increment_m is',
!     +         new_thickness_increment_m
              prior_thickness_increment_= current_thickness_increment_m
              current_thickness_increment_m= new_thickness_increment_m
              thickness_increment_m    = current_thickness_increment_m
              thickness_increment_km   = thickness_increment_m * m2km
              go to 150  ! start of this do loop
              option = option_default
              
             endif

!            set velocity increment
             if(option.eq.changeVincrement_opt) then
!             read new velocity increment value
               call readVincrement_file(newVincrement_mps,
     +              inboundVincrement)
!               print*,'L918 new Vincrement is',newVincrement_mps
               priorVincrement_mps         = currentVincrement_mps
               currentVincrement_mps       = newVincrement_mps
               Vincrement_mps              = currentVincrement_mps
               Vincrement_kmps             = Vincrement_mps * m2km
               go to 150 ! start of this do loop
               option = option_default

             endif

             if(option.eq.changeVbotNtop_factor_opt) then
!             read new velocity factor value
              call readVbotNtop_factor_file(
     +               newVbotNtop_factor,inboundVbotNtop_factor)
!               print*,'L 655 new VbotNtop_factor:',newVbotNtop_factor
               priorVbotNtop_factor     = currentVbotNtop_factor
               currentVbotNtop_factor   = newVbotNtop_factor
               VbotNtop_factor          = currentVbotNtop_factor
               go to 150 ! start of this do loop
               option = option_default

             endif

!
! *** Options that require
!     recomputation and replot of  X-T curves

             if(option.eq.changeVbot_upper_layer_opt) then
!             read new bottom velocity  value
               call readVbot_upper_file(newVbot_upper,inboundVbot_upper)

               priorVbot_upper         = currentVbot_upper
               currentVbot_upper       = newVbot_upper
               Vbot_upper_mps          = currentVbot_upper
               Vbot_upper_kmps       = currentVbot_upper * m2km
               VB(current_layer_number-1) = Vbot_upper_kmps
!               print*,'L786 new Vbot_upper', VB(current_layer_number-1)
!               go to 150 ! start of this do loop

!              write modified model to terminal after
!              changing bottom velocity of upper layer
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif

             if(option.eq.changeVtop_lower_layer_opt) then
!             read new bottom velocity  value
!               print*,'L794,changing Vtop_lower_layer'
               call readVtop_lower_file(newVtop_lower,inboundVtop_lower)
!               print*,'L 797 new Vtop_lower is',newVtop_lower
               priorVtop_lower         = currentVtop_lower
               currentVtop_lower       = newVtop_lower
               Vtop_lower_mps          = currentVtop_lower
                Vtop_lower_kmps          = currentVtop_lower * m2km
               VT(current_layer_number+1) = Vtop_lower_kmps
!                print*,'L803 new Vtop_lower',VT(current_layer_number+1)
!               go to 150 ! start of this do loop

!              write modified model to terminal after
!              changing top velocity of lower layer
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif

             if(option.eq.changeVbot_opt) then
             
             ! read new bottom velocity  value
               call readVbot_file(newVbot,inboundVbot)
               print*,'L 964 new Vbot is',newVbot
               priorVbot         = currentVbot
               currentVbot       = newVbot
               Vbot_mps          = currentVbot
               Vbot_kmps          = currentVbot  * m2km
               VB(current_layer_number) = Vbot_kmps
!               go to 150 ! start of this do loop

!              write modified model to terminal after
!              changing bottom velocity
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif

             if(option.eq.changeVtop_opt) then
             
!             print*,'L 979 changeVtop_opt=',changeVtop_opt
!             read new bottom velocity  value
               call readVtop_file(newVtop,inboundVtop)
               print*,'L 982  new Vtop is',newVtop
               priorVtop         = currentVtop
               currentVtop       = newVtop
               Vtop_mps          = currentVtop
               Vtop_kmps         = currentVtop * m2km
               VT(current_layer_number) = Vtop_kmps
!               go to 150 ! start of this do loop

!              write modified model to terminal after
!              changing top velocity in layer
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif
             
             if(option.eq.Vbot_minus_opt) then
                VB(current_layer_number) =
     +          VB(current_layer_number) - Vincrement_kmps
!                print*,'immodpg.for,Vbot_minus_option=',Vbot_minus_opt
!                print*,'immodpg.for,Vbot_minus=',VB(current_layer_number)

!              write modified model to terminal after
!              changing bottom velocity
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.Vbot_plus_opt) then
                VB(current_layer_number) =
     +          VB(current_layer_number) + Vincrement_kmps
!                print*,'immodpg.for,Vbot_plus_option=',Vbot_plus_opt
!                print*,'immodpg.for,Vbot_plus=',VB(current_layer_number)

!              write modified model to terminal after
!              changing bottom velocity
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.Vtop_minus_opt) then
                VT(current_layer_number) =
     +          VT(current_layer_number) - Vincrement_kmps
!                 print*,'immodpg.for,option=',Vtop_minus_opt
!                print*,'immodpg.for,Vtop_minus=',VT(current_layer_number)

!              write modified model to terminal after
!              changing top velocity
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.Vtop_plus_opt) then
                 VT(current_layer_number) =
     +           VT(current_layer_number) + Vincrement_kmps
!                 print*,'immodpg.for,option=',Vtop_plus_opt
!                 print*,'immodpg.for,Vtop_plus=',VT(current_layer_number)

!              write modified model to terminal after
!              changing bottom velocity -- had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif
!             if(option.eq.3) DZ(current_layer_number) =
!     + DZ(current_layer_number) + a1
!
             if(option.eq.VbotNVtop_minus_opt) then
                     VT(current_layer_number) =
     +         VT(current_layer_number) - Vincrement_kmps
                     VB(current_layer_number) =
     +         VB(current_layer_number) - Vincrement_kmps

!               print*,'immodpg.for,option=',VbotNVtop_minus_opt
!               print*,'immodpg.for,option=VT',VT(current_layer_number)
!               print*,'immodpg.for,option=VB',VB(current_layer_number)
               
!              write modified model to terminal after
!              changing both bottom and top velocities in a layer
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.VbotNVtop_plus_opt) then
                     VT(current_layer_number) =
     +         VT(current_layer_number) + Vincrement_kmps
                     VB(current_layer_number) =
     +         VB(current_layer_number) + Vincrement_kmps
!               print*,'immodpg.for,option=',VbotNVtop_plus_opt
!               print*,'immodpg.for,option=VT',VT(current_layer_number)
!               print*,'immodpg.for,option=VB',VB(current_layer_number)

!              write modified model to terminal after
!              changing both bottom and top velocities in a layer
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif

             if(option.eq.VtopNVbot_upper_layer_minus_opt
     +         .and. current_layer_number.gt.1) then

               upper_layer_number = current_layer_number -1

               VT(current_layer_number) =
     +         VT(current_layer_number) - Vincrement_kmps

               VB(upper_layer_number) =
     +         VB(upper_layer_number) - Vincrement_kmps

!              print*,'immodpg.for,option=',VtopNVbot_upper_layer_minus_opt
!              print*,'immodpg.for,VT=',VT(current_layer_number)
!              print*,'immodpg.for,VB_upper=',VB(upper_layer_number)
!              print*,'immodpg.for,Vincrement_kmps=',Vincrement_kmps

!              write modified model to terminal after
!              changing both top velocity in the current layer
!              and bottom velocity in the layer above
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.VtopNVbot_upper_layer_plus_opt
     +         .and. current_layer_number.gt.1) then

              VT(current_layer_number) =
     +        VT(current_layer_number) + Vincrement_kmps

              VB(current_layer_number-1) =
     +        VB(current_layer_number-1) + Vincrement_kmps
!              print*,'immodpg.for,option=',VtopNVbot_upper_layer_plus_opt
!              print*,'immodpg.for,VT=',VT(current_layer_number)
!              print*,'immodpg.for,VB_upper=',VB(current_layer_number-1)
!              print*,'immodpg.for,Vincrement_kmps=',Vincrement_kmps

!              write modified model to terminal after
!              changing both top velocity in the current layer
!              and bottom velocity in the layer above
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.VbotNVtop_lower_layer_minus_opt
     +         .and. current_layer_number.lt.nl) then

              VT(current_layer_number) =
     +        VT(current_layer_number) - Vincrement_kmps

              VB(current_layer_number+1) =
     +        VB(current_layer_number+1) - Vincrement_kmps
!             print*,'immodpg.for,option=',VbotNVtop_lower_layer_minus_opt

!              write modified model to terminal after
!              changing both top velocity in the current layer
!              and bottom velocity in the layer above
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.VbotNVtop_lower_layer_plus_opt
     +         .and. current_layer_number.lt.nl) then

              VT(current_layer_number) =
     +        VT(current_layer_number) + Vincrement_kmps

              VB(current_layer_number+1) =
     +        VB(current_layer_number+1) + Vincrement_kmps
!              print*,'immodpg.for,option=',VbotNVtop_lower_layer_plus_opt

!              write modified model to terminal after
!              changing both bottom velocity in the current layer
!              and top velocity in the layer below
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default

             endif

             if(option.eq.VbotNtop_multiply_opt) then
               VT(current_layer_number) =
     +             VbotNtop_factor * VT(current_layer_number)
               VB(current_layer_number) =
     +             VbotNtop_factor * VB(current_layer_number)
!                print*,'immodpg.for,option=',VbotNtop_multiply_opt

!              write modified model to terminal after
!              scaling both bottom and top velocities 
!              in the current layer
!              by multiplication
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

             if(option.eq.change_thickness_m_opt) then
             
!              print*,'L1197 immodpg.for,option=',change_thickness_m_opt
                call read_thickness_m_file(
     +                    new_thickness_m,inbound_thickness_m)
                prior_thickness_m   = current_thickness_m
                current_thickness_m = new_thickness_m
                current_thickness_km = new_thickness_m * m2km
                DZ(current_layer_number) = current_thickness_km
!                go to 150 ! start of this do loop
                
!              write modified model to terminal after
!              changing the current layer thickness
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default               
                
             endif

             if(option.eq.thickness_m_plus_opt) then
             
!             print*,'immodpg.for,option=', thickness_m_plus_opt
               
               DZ(current_layer_number) =
     +         DZ(current_layer_number) + thickness_increment_km
  
!               print*,'immodpg.for L1208,new_thickness='
!               print*,DZ(current_layer_number)
     
!              write modified model to terminal after
!              changing the current layer thickness
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default
               
             endif

               if(option.eq.thickness_m_minus_opt) then
               
!                print*,'immodpg.for,option=', thickness_m_minus_opt
!                print*,'immodpg.for,th_inc_km=', thickness_increment_km

               DZ(current_layer_number) =
     +         DZ(current_layer_number) - thickness_increment_km
       
!              write modified model to terminal after
!              changing the current layer thickness
!              had no option_default before
               call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
               option = option_default      

             endif

!             if(option.eq.3) DZ(current_layer_number) =
!     +        DZ(current_layer_number) + a1

!             exit do loop + all interaction
             if(option.eq.exit_opt) then
!               print*,'exiting from immodpg.for'
!              return option file to default (= -1)
!              print*,'immodpg.for,option=', exit_opt
              go to 255
           endif
           
      go to 10 ! start of all interactions with user
!          stay in do loop
           else
!              print *, 'L 1249 read_yes_no_file.f,is_change=',is_change
           endif

       end do ! end of loop that detects changes in GUI

!
!	if(option.eq.10) then
!		call read_par_r4('New dp (s/km) ??',dp)
!       endif
!

!
! **************************

!     START of loop that detects changes in the GUI
!     END of first plot that will be repeated

!        if option is good then carry out the instruction
!          instruction
!             e.g., read what layer we should work on
!             read layer number
!             replot the layer in question
!             make sure instruction is complete before a new change is implemented
!        go and check to see if there is another change
!      end the loop


      icolor = 0
      call pgpage   ! clear screen
      call pgsci(1) ! set color index
!      print *, 'L 576 clear screen'

      go to 10 ! START of ALL interactions with USER

255   continue  ! leave if option_exit
!          print*,'L1047 Vtop_lower',VT(current_layer_number+1)
!          print*,'L1048 VB_upper=',VB(current_layer_number-1)
!       write modified file to a text file
       call write_model_file_text(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB,
     + outbound_model_txt);
!
! write modified model to terminal
!
	write(*,*) ' '
	write(*,*) 'MODIFIED MODEL:'
	call WRIMOD2(nl,VT,VB,DZ,VST,VSB,RHOT,RHOB)
!
! write modified model to file immodpg.out
!
        OPEN(UNIT=IOUT,FILE=outbound_model_bin,STATUS='UNKNOWN',
     +  FORM='UNFORMATTED')
        do K=1,NL+1
        	write(IOUT) VT(K),VB(K),DZ(K),
     +  	VST(K),VSB(K),RHOT(K),RHOB(K)
        enddo
        CLOSE(UNIT=IOUT)
!
! write backup modified model to file immodpg.out
!
        OPEN(UNIT=IOUT,FILE=outbound_model_bin_bck,
     +  STATUS='UNKNOWN', FORM='UNFORMATTED')
        do K=1,NL+1
              write(IOUT) VT(K),VB(K),DZ(K),
     +        VST(K),VSB(K),RHOT(K),RHOB(K)
        enddo
        CLOSE(UNIT=IOUT)


! write first breaks out
!
!        OPEN(UNIT=IOUT,FILE='immodpg.XT',STATUS='UNKNOWN',
!     +  FORM='UNFORMATTED')
!        do K=1,NL+1
! for each layer write out pairs of x and t
!           do J = 1,array_npt(K)
!        	write(IOUT) xout(J,K),tout(J,K)
!          enddo
!        enddo
!        CLOSE(UNIT=IOUT)

! write out the TX pairs for all the layers
!
        write(*,*) 'This model has been written to file:'
        write(*,*) '***     immodpg.out     ***'
!
        call pgend
500     format(' 1-  VTOP = ',f7.5,',            2-  VBOT = ',f7.5,' (km
     +/s)')
502     format(' 3-  DZ   = ',f7.5,' (km)',',       4-  VTOP and VBOT')
503     format(' 7-  Increment = ',f7.5,' (km or km/s)')
504     format(' 9-  Clip for data,            10- DP = ',f9.6,
     +' (s/km)')
        end
        
      ! usleep.f90
      module posix
       use, intrinsic :: iso_c_binding, only: c_int, c_int32_t
       implicit none

       interface
        ! int usleep(useconds_t useconds)
        function c_usleep(useconds) bind(c, name='usleep')
         import :: c_int, c_int32_t
         integer(kind=c_int32_t), value :: useconds
          integer(kind=c_int)            :: c_usleep
        end function c_usleep
       end interface
      end module posix
        

	subroutine read_dataxy(x,y,n,fin,iin,iwrit)
!
! Reads file containing (x,y) pairs and an arbitrary number of
! comment lines
! before these pairs. The (x,y) pairs are returned in arrays x and y.
! The
! comment lines are written on the terminal.
!
! n     = number of (x,y) pairs in the file (output).
!
! fin   = Default input file name (input)
! iin   = reading input unit (input).
! iwrit = if iwrit.eq.1, (x,y) pairs are written on screen (input).
!
	dimension x(*),y(*)
	character*40 fin
	character*40 comment
	LOGICAL EX
!
!  ********* read input file *********
!
! Check for default file "fin".  If file does not exist, then
! ask for a file name
!
!       write(*,*) fin
	go to 117
115     write(*,*) 'Input File Name ?? '
	READ(*,'(A)') fin
117	INQUIRE(FILE=fin,EXIST=EX)
	IF(.NOT.EX) THEN
	write(*,*) 'There is no trace defined'
	GO TO 115
	ENDIF
	OPEN(UNIT=iin,FILE=fin,STATUS='OLD')
!
	n = 1
	write(*,*)
120	continue
	READ(iin,'(a)',end=170,err = 150) comment
	read(comment,*,err = 150) xa,ya
	x(n) = xa
	y(n) = ya
	n = n + 1
	go to 120
150	continue
!       write(*,'(a)') comment
	go to 120
170	continue
	close(iin)
	n = n - 1
! ************************************************************
	if(n.ge.1) then
	   if(iwrit.eq.1) then
		write(*,*) '** Digitized traveltime data ** '
		write(*,*) ' '
		write(*,*) '            X(km)          T(sec)'
		write(*,*) ' '
		do i = 1,n
		  write(*,300) i,x(i),y(i)
		end do
		write(*,*) ' '
	   endif
	else
	write(*,*) '** There is no line containing data in this file **'
	endif
	
300	format(i5,2f15.6)

	return
	end

      subroutine readVbot_upper_file(result,inbound)
         implicit none
!       read a configuration file

      real*4      :: result
      character (len=255) :: inbound, inbound_locked
      character (len=30) :: format1
      integer :: err_msg, ready

      inbound_locked=trim(inbound)//"_locked"
      format1=  "(F7.1)"

!      print *, 'readVbot_upper_file.f, inbound is:', trim(inbound)
!      in case inbound is of a different, but shorter length in main
!      create a temporary, new, lock file

10     open(status='new',unit=30,file=inbound_locked,iostat=ready)

       if (ready.eq.0) then
         open(unit=29,file=trim(inbound),status='old',iostat=err_msg)
      
 !       check whether file opens data file
         if (err_msg.eq.0) then

!          print *, 'readVbot_upper_file.f'
          read (29,format1) result
!          print *, 'readVbot_upper_file.f, result',result
          close (unit=29)

         else
          print *,'readVbot_upper_file.f,locked, try again,read =',ready
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if

!       remove lock file
11      close (status='delete',unit=30,iostat=err_msg)
        if (err_msg.ne.0) then
         go to 11
         print *, 'readVbot_upper_file.f, err_messg=',err_msg
        end if

       end if
!       print *, 'readVbot_upper_file, result',result
      end subroutine readVbot_upper_file

      subroutine read_parmmod_file(inbound,ntr,ns,idtusec)
         implicit none
!       read a configuration file

      character (len=255) :: inbound, inbound_locked
      integer*4  ntr,ns,idtusec
      integer :: err_msg, ready

!      print *, 'read_parmmod_file, inbound is:',trim(inbound),'--'
!      in case inbound is of a different, but shorter length in main
      inbound=inbound
      inbound_locked=trim(inbound)//"_locked"

10     open(status='new',unit=25,file=inbound_locked,iostat=ready)

        if (ready.eq.0) then
         open(unit=26,file=trim(inbound),status='old',iostat=err_msg)

!       check whether file opens data file
         if (err_msg.eq.0) then

          read (26,*) ntr,ns,idtusec
!       print *, 'read_parmmod_file, results',ntr,ns,idtusec
!          print *, 'read_parmmod_file.f, result',ntr
          close (unit=26)

         else
!         print *, 'read_parmmod_file.f, err_msg=',err_msg
!         print *, 'read_parmmod_file.f, counter=',counter
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if
       else
         print *, 'read_parmmod_file.f,locked, try again,read =',ready
         go to 10
       end if
!       remove lock file
11      close (status='delete',unit=25,iostat=err_msg)
        if (err_msg.ne.0) then
         go to 11
         print *, 'read_parmmod_file.f, err_messg=',err_msg
        end if

      end subroutine read_parmmod_file

	SUBROUTINE THI(TWTT,VT,VB,DZ)
C
C THIS SUBROUTINE COMPUTES THE THICKNESS DZ OF A CONSTANT VEL. GRADIENT 
C LAYER WHEN THE 2-WAY TRAVELTIME FOR THE LAYER (TWTT),TOP AND BOTTOM
C VELOCITIES (VT,VB) ARE KNOWN.THE SPECIAL CASE VT=VB(HOMOGENEOUS LAYER)
C IS ALSO INCLUDED.
C
	IF(VT.NE.VB) GO TO 1
	DZ=TWTT*VT/2.
c HOMOGENEOUS LAYER
	RETURN
C
 1	AUX=(VB-VT)/ALOG(VB/VT)
	DZ=TWTT*AUX/2.
c CONSTANT VEL. GRADIENT LAYER
	RETURN
	END

	SUBROUTINE READMMOD(VT,VB,DZ,VST,VSB,RHOT,RHOB,NL)
	DIMENSION VT(*),VB(*),DZ(*),VST(*),VSB(*),RHOT(*),RHOB(*)
	CHARACTER*40 FOUT
	CHARACTER*8 STAT
!      JML 20, 3 lines foll.
	real*4    result(20)
	character*40  model_file_in, base_file
	character*255 set_DIR, get_DIR, config_file_in
	character*255 inbound_config, inbound_model
	real      previous_model,new_model
	LOGICAL EX
	IOUT=25
	IIN=26
	IOP=3
	model_file_in='immodpg.out'
	config_file_in = 'immodpg.config'
	idef=0
	ID=0


c READS A VELOCITY DEPTH MODEL OF NL LAYERS. VT(I),VB(I),DZ(I) ARE TOP
c AND BOTTOM P-WAVE VELOCITIES AND THICKNESS OF LAYER I AND VST(I),
c VSB(I),RHOT(I),RHOB(I) ARE ITS S-WAVE VELOCITY AND DENSITY AT
c TOP AND BOTTOM RESPECTIVELY.
c

! read all the configuration parameters for the Current Project
! to define the different needed directories
      set_DIR = "IMMODPG"
      call Project_config(set_DIR,get_DIR)
      inbound_config = trim(get_DIR)//"/"//config_file_in
      inbound_model = trim(get_DIR)//"/"//model_file_in
!      print*, '1. readmmod.for,inbound=',trim(inbound),'--'

! read all the configuration parameters for mmodpg JML 2020
!      next 7 lines
      call read_immodpg_config(base_file,result,inbound_config)
      previous_model = result(14)
      new_model      = result(15)
!      print*, '1. readmmod.for,previous_model=',previous_model,'--'
!      print*, '1. readmmod.for,new_model=',new_model,'--'
      if (previous_model == 0.0 .and. new_model == 1.0) then
       ID=1
       write(*,*) '1- CREATE A GRADIENT VEL. MODEL (Binary FORMAT)'
       CALL READ_PAR_I4('0- READ/MODIFY OLD MODEL ',ID)

      else if (previous_model == 1.0 .and. new_model == 0.0) then
       ID =0
!       print *, 'L49 readmmod.for, correct answer'
      else
       print *, 'readmmod.for, unexpected model answer'
      end if

	IF(ID.EQ.0) go to 110
c
	ID=2
	write(*,*) 'DEFINE THE MODEL USING :'
	write(*,*)
	CALL READ_PAR_I4('0-DEPTH,1-TWTT(P-WAVE),2-LAYER THICKNESS',ID)
c
        write(*,*) 'ENTER P- WAVE VELOCITIES(KM/SEC) AND ACCORDING'
        write(*,*) 'TO YOUR PREVIOUS CHOICE ENTER EITHER DEPTH(KM)'
        write(*,*) 'OR 2-WAY TRAVEL TIME(SEC) TO THE BOTTOM OF'
        write(*,*) 'THE LAYER OR THICKNESS(KM).'
        write(*,*) '*** GIVE VPTOP= NEGATIVE NUMBER TO END .***'
	write(*,*)
	write(*,*) 'INITIALLY THE SHEAR VELOCITIES WILL BE SET'
	write(*,*) 'ACCORDING TO THE SPECIFIED VS/VP RATIO, AND THE'
	write(*,*) 'DENSITIES BY:'
	write(*,*)
	write(*,*) '** IOP=1 **'
	write(*,*) 'RHO=1.74*VP**0.25 ,GARDNER ET AL.,GEOPHYSICS 39,'
	write(*,*) '                   P 770-780,1974'
	write(*,*) '** IOP=2 **'
	write(*,*) 'RHO=1.85+0.165*VP ,CHRISTENSEN AND SHAW,GEOPHYS.J.R'
	write(*,*) '                   ASTR.SOC.,P 271-284,1970; BASALT'
	write(*,*) '                   SAMPLES AT 1 KBAR.'
	write(*,*) '** IOP=3 **'
	write(*,*) ' NAFE AND DRAKE, THE SEA VOL.4,PART 1,WILEY-INTER-'
	write(*,*) 'SCIENCES,NEW YORK,1970.'
	write(*,*)
	write(*,*) 'FOR THE FIRST LAYER VS=0.0, RHO=1.0'
	write(*,*)
	VSVPR=0.0
	CALL READ_PAR_R4('VS/VP RATIO TO DEFAULT VS?',VSVPR)
	CALL READ_PAR_I4(' IOP TO DEFINE DENSITIES ?',IOP)
c
	I=1
	DE1=1.5
	AU1=0.
 10	write(*,*) 'LAYER ',I
	write(*,*)
	VT(I)=DE1
	CALL READ_PAR_R4('VPTOP (KM/SEC) ?',VT(I))
	IF(VT(I).LT.0) GO TO 100
	CALL READ_PAR_R4('VPBOTTOM (KM/SEC) ?',VB(I))
	CALL READ_PAR_R4('DEPTH OR TWTT OR THICKNESS (KM OR SEC)?',AU2)
	VST(I)=VSVPR*VT(I)
	VSB(I)=VSVPR*VB(I)
	CALL DENFVP(VT(I),RHOT(I),IOP)
	CALL DENFVP(VB(I),RHOB(I),IOP)
	IF(I.EQ.1) THEN
	VST(I)=0.0
	VSB(I)=0.0
	RHOT(I)=1.0
	RHOB(I)=1.0
	ENDIF
	CALL READ_PAR_R4(
     +  'VSTOP (KM/SEC)? (ENTER 0.0 TO DEFINE A FLUID)',VST(I))
	CALL READ_PAR_R4(
     +  'VSBOTTOM (KM/SEC)? (ENTER 0.0 TO DEFINE A FLUID)',VSB(I))
	CALL READ_PAR_R4('TOP DENSITY (G/CC) ?',RHOT(I))
	CALL READ_PAR_R4('BOTTOM DENSITY (G/CC) ?',RHOB(I))
c
	IF(ID.EQ.0) THEN
	DZ(I)=AU2-AU1
	AU1=AU2
	ELSE
		IF(ID.EQ.1) THEN
		AU3=AU2-AU1 ! LAYER I TWO WAY TRAVEL TIME
		AU1=AU2
		CALL THI(AU3,VT(I),VB(I),DZ(I))
		ELSE
		DZ(I)=AU2
		ENDIF
	ENDIF
	I=I+1
	DE1=VB(I-1)
	GO TO 10
100	NL=I-1
   	VB(I)=0.0
	DZ(I)=0.0
	VST(I)=0.0
	VSB(I)=0.0
	RHOT(I)=0.0
	RHOB(I)=0.0
c
c *** WRITE MODEL IN FILE ***
c
97      ID=1
  	CALL READ_PAR_I4('1- WRITE MODEL IN FILE, 0- NO',ID)
	IF(ID.EQ.0) GO TO 135
	STAT='NEW'
103	write(*,*)'OUTPUT FILE NAME ?? '
	READ(*,'(A)') FOUT
	INQUIRE(FILE=FOUT,EXIST=EX)
	IF(EX) THEN
	write(*,*) 'FILE ALREADY EXISTS: 1- OVERWRITE IT,0- TRY ',
     +  'AGAIN WITH A NEW NAME'
	read(5,*) ID
		IF(ID.EQ.0) GO TO 103
		IF(ID.EQ.1) STAT='UNKNOWN'
	ENDIF
	OPEN(UNIT=IOUT,FILE=FOUT,STATUS=STAT,FORM='UNFORMATTED')
	DO K=1,NL+1
	write(IOUT) VT(K),VB(K),DZ(K),VST(K),VSB(K),RHOT(K),RHOB(K)
	ENDDO
	CLOSE(UNIT=IOUT)
	GO TO 135

! *** READ OLD MODEL FROM DISK ***

110	INQUIRE(FILE=inbound_model,EXIST=EX)
!      print *, 'readmmod.for,inbound_model=',inbound_model
        IF(EX) then
!		write(*,*) ''
!		write(*,*) 'readmmod,Default file immodpg.out exists.'
!		write(*,*) ''
!      call read_par_i4('0- use it , 1- No',idef)
!              if(idef.eq.1) 117
              go to 117
	 else
	       print *, 'Default file immodpg.out is missing!'
 !             if(idef.eq.1) go to 115
              go to 115

	end if

c
115     write(*,*) 'INPUT FILE NAME ?? '
	READ(5,'(A)') inbound_model
	INQUIRE(FILE=inbound_model,EXIST=EX)
	IF(.NOT.EX) THEN
	write(*,*)'FILE DOES NOT EXIST, TRY AGAIN WITH A NEW NAME'
	GO TO 115
	ENDIF
c
117	continue
	OPEN(UNIT=IIN,FILE=inbound_model,STATUS='OLD',FORM='UNFORMATTED')
	K=1
120     READ(IIN) VT(K),VB(K),DZ(K),VST(K),VSB(K),RHOT(K),RHOB(K)
	IF(VT(K).LT.0.) GO TO 125
	K=K+1
	GO TO 120
125	NL=K-1
c
	CLOSE(UNIT=IIN)
!   	write(*,*)'readmmod,FILE = ',inbound_model
	CALL WRIMOD2(NL,VT,VB,DZ,VST,VSB,RHOT,RHOB)
c
c *** MODIFICATIONS ***
c
	ID=0
!	Juan's modification for immodpg.for July 25 2020
!       write(*,*) 'readmmod.for L207'
!	CALL READ_PAR_I4('CHANGE THIS FILE? 1-YES 0-NO',ID)
!        write(*,*) 'readmmod.for L209 ID=', ID
!       FORCE NO READING OF MODEL
	ID=0
	IF(ID.NE.1) GO TO 135
127	write(*,*)'1-DELETE OR 2-INSERT AFTER LAYER,3- CHANGE LAYER '
	read(5,*) IMOD
	write(*,*)'LAYER NUMBER ?? '
	read(5,*) LNU
c
	IF(IMOD.EQ.1) THEN
	DO K=LNU,NL
   	VT(K)=VT(K+1)
	VB(K)=VB(K+1)
	DZ(K)=DZ(K+1)
	VST(K)=VST(K+1)
	VSB(K)=VSB(K+1)
	RHOT(K)=RHOT(K+1)
	RHOB(K)=RHOB(K+1)
	ENDDO
	NL=NL-1
	GO TO 130
	ENDIF
c
	I=LNU
	IF(IMOD.EQ.2) THEN
	K=NL+1
	I=LNU+1
57	CONTINUE
   	VT(K+1)=VT(K)
	VB(K+1)=VB(K)
	DZ(K+1)=DZ(K)
	VST(K+1)=VST(K)
	VSB(K+1)=VSB(K)
	RHOT(K+1)=RHOT(K)
	RHOB(K+1)=RHOB(K)
	K=K-1
	IF(K.GE.I) GO TO 57
	NL=NL+1
	VB(I)=VT(I+1)
	VSB(I)=VST(I+1)
	RHOB(I)=RHOT(I+1)
	VT(I)=VB(LNU)
	VST(I)=VSB(LNU)
	RHOT(I)=RHOB(LNU)
	ENDIF
	write(*,*)
	CALL READ_PAR_R4('VPTOP (KM/SEC) ?',VT(I))
	CALL READ_PAR_R4('VPBOTTOM (KM/SEC) ?',VB(I))
	CALL READ_PAR_R4('THICKNESS (KM)?',DZ(I))
	CALL READ_PAR_R4('VSTOP (KM/SEC) ?',VST(I))
	CALL READ_PAR_R4('VSBOTTOM (KM/SEC) ?',VSB(I))
	CALL READ_PAR_R4('TOP DENSITY (G/CC) ?',RHOT(I))
	CALL READ_PAR_R4('BOTTOM DENSITY (G/CC) ?',RHOB(I))
c
130	write(*,*)' MODIFIED MODEL ***'
	write(*,*)' '
	CALL WRIMOD2(NL,VT,VB,DZ,VST,VSB,RHOT,RHOB)
	write(*,*)' '
	write(*,*)'1- MORE MODIFICATIONS, 0- NO '
	read(5,*) ID
	IF(ID.EQ.1) GO TO 127
	IF(ID.EQ.0) GO TO 97
135	CONTINUE
	RETURN
	END

      subroutine readVincrement_file(result,inbound)
         implicit none
!       read a Vincrement file

      real*4              :: result
      character (len=255) :: inbound, inbound_locked
      character (len=30)  :: format1
      integer :: err_msg, ready

      inbound_locked=trim(inbound)//"_locked"
      format1= "(F5.1)"
!      create a temporary, new, lock file
10     open(status='new',unit=30,file=inbound_locked,iostat=ready)

        if (ready.eq.0) then
         open(unit=31,file=trim(inbound),status='old',iostat=err_msg)

!       check whether file opens data file
         if (err_msg.eq.0) then

           read (31,format1) result
          print *, 'readVincrement_file.f, result',result
          close (unit=31)

         else
!         print *, 'readVincrement_file.f, err_msg=',err_msg
!         rest a little before trying again
!         call sleep(1)
          go to 10
         end if
       else
         print *, 'readVincrement_file.f,locked, try again,read =',ready
         go to 10
       end if
!       remove lock file
11      close (status='delete',unit=30,iostat=err_msg)
        if (err_msg.ne.0) then
         go to 11
         print *, 'readVincrement_file.f, err_messg=',err_msg
        end if
!       print *, 'readVincrement_file, result',result

      end subroutine readVincrement_file

sudo  perl ./dist/manifest.pl
# make sure to force /script/L_SU_project_selector.pl into MANIFEST
sudo perl Makefile.PL
sudo make all
sudo make test
sudo perl clean_unwanted_subdirectory.pl
sudo make install
sudo make dist

#!/bin/bash

# starting variable definitions
starting_points='/home /'
priority_level='-O3'
file='f'
case=1
repeat=1
continue=0
default_answer="y"

# see if a global variable is set
# SeismicUnixGui_script is a global variable for locating the script folder

echo -e "\n\tGLOBAL VARIABLES*********************"
 if [ -z "${SeismicUnixGui_script}" ]; then
	
 	echo  " Global variable SeismicUnixGui_script should be set"
 	echo " e.g.,in .bashrc you should have a line as follows: "
 	echo -e " export SeismicUnixGui_script=/Location/of/script/folder \n"
 	
 else
 	echo " "
        echo -e " Global variable SeismicUnixGui_script currently is:\
 ${SeismicUnixGui_script}\n"
 fi
 
# Parameters to find a needed file
# find -print0 option produces null delimited strings so spaces, 
# tabs and carriage return in file names are preserved safely.

# restart a search
choice=1
ans=0
hint_ans=''
Afile2find="post_install_fortran_compile.pl"
# read the list of files and their paths

echo -e " Please be patient."
echo -e " Looking for scripts to compile fortran and C code  ...\n"
echo -e " Hint: Choose a path with \"bin/$Afile2find\" in its name."
echo -e " A local installation also has \"perl5/bin\" in the path."
echo -e " Ignore the case with \"blib\" in its path.\n"
readarray -d '' -t list < <(find $starting_points -type $file -name $Afile2find -print 2>/dev/null )
length=${#list[@]}
echo -e "Found $length post-installation script(s) to run:\n"

for each in ${list[@]}
do
    echo "Case $case:   $each"
    ((case=case+1))
    
    # quiet: -q; ignorable cases
     echo $each | grep -q blib
     ((ans=$?))
    
     if [[ $ans == 0 ]]; then  
       echo "Ignore"   
     elif [[ $ans == 1 ]]; then    
       hint_ans=$each      
     else 
       echo "unexpected L 65"
     fi
    
done

while [ $choice == $repeat ]; do
	# echo "choice is $choice and repeat is $repeat"
	echo -e "\nEnter first script name (with Full Path),\n or use the default: [$hint_ans]\n"
	read -r -p "Enter a name or only Hit Return:" input

	# check for content
	if [ -z "$input" ]; then
	   script_name=$hint_ans
	else
	   script_name=$input
	fi

	echo -e "OK, we will use: $script_name\n"
	read -p "Please confirm (y/n)? [$default_answer]:" answer

	# check for content
	if [ -z "$answer" ]; then
	   ((choice=$continue))	 		     
	elif [[ "$answer" == "n" ]]; then
	   echo "choicen=$choice"	  
	elif [[ "$answer" == "y" ]]; then
	    ((choice=$continue))
	else
	    echo "uenxpected L 92"
	fi

 done
echo -e "\n perl $script_name\n"
perl $script_name

# finished with programs in Fortran

c_script_name=$(echo $script_name | sed -e 's/fortran/c/')
# Now, for C programs -- read the list of files and their paths
echo -e "\nNow, looking for scripts to compile C code  ..."
echo -e "\nNext script name=$c_script_name"
echo "Looking for $c_script_name to compile  C code  ..."
perl $c_script_name

# env_script_name=$(echo $script_name | sed -e 's/fortran_compile/env/')
# echo -e "environment script=$env_script_name"
# sudo perl $env_script_name

#!/bin/bash

local_dir=`pwd`
# echo "local directory=$local_dir"
source $local_dir/.temp
echo "source $local_dir/.temp"
# see if global variable is set
# global variable SeismicUnixGuilocates main folder

 if [ -z "${SeismicUnixGui}" ]; then

 	echo "global variable SeismicUnixGui must first be set"
 	echo "e.g. in .bashrc: "
 	echo " export SeismicUnixGui=/Location/of/folder "

 else
	echo "SeismicUnixGui =" ${SeismicUnixGui}
 fi

#!/bin/bash
# make clean
# if read from stdin
# uncomment the next line
# pgplot_dir=$1
pgplot_dir=/usr/local/pgplot
export PGPLOT_DIR=$pgplot_dir
echo "PGPLOT_DIR is now: $PGPLOT_DIR"
make immodpg1.1
